# -*- encoding: utf-8 -*-
##############################################################################
#
# Copyright (c) 2009 All Rights Reserved. Luiz Fernando Maciel Franca
#                    www.siginformatica.com.br luiz@siginformatica.com.br
#
##############################################################################

from openerp.osv import osv, fields


class financeiro_titulo(osv.Model):
    _name = 'financeiro.titulo'
    _inherit = 'financeiro.titulo'
    _columns = {
        'fintit_pgm_banco_pagador': fields.char('Banco pagador', size=3, select=1,
                                                help='Banco onde o titulo foi enviado para pagamento'),
        'fintit_pgm_data_pagamento': fields.date('Data para pagamento',
                                                 help='Data definida para pagamento do titulo'),
        'fintit_pgm_valor': fields.float('Valor para pagamento',
                                         help='Valor definido para pagamento'),
        'fintit_pgm_data_hora_geracao': fields.datetime('Data/Hora da geracao',
                                                        help='Data e hora que a remessa foi gerada'),
        'fintit_pgm_retorno_confirmado': fields.boolean('Retorno confirmado',
                                                        help='Indica que ja recebeu o arquivo de retorno'),
        'fintit_pgm_operacao': fields.selection([('000', '000-Inclusao de pagamento'),
                                                 ('517', '517-Alteracao de valor de pagamento'),
                                                 ('519', '519-Alteracao de data de pagamento'),
                                                 ('999', '999-Exclusao de pagamento incluido')],
                                                'Operacao', size=3),
        'fintit_baixa_arquivo_retorno': fields.boolean('Baixado por arquivo de retorno',
                                                       help='Baixa realizada automaticamente pela '
                                                            'importacao do arquivo de retorno '
                                                            'emitido pelo banco.'),
    }
    _defaults = {
        'fintit_baixa_arquivo_retorno': lambda *a: False,
    }

