# -*- coding: utf-8 -*-

import xmlrpclib
import socket
from re import sub


class Connection(object):
    def __init__(self):
        self.database = str(raw_input('Nome do banco de dados: '))
        self.host = str(raw_input('Host/IP OpenERP: '))
        self.user = str(raw_input('Usuario OpenERP: '))
        self.password = str(raw_input('Senha OpenERP: '))
        self.door = raw_input('Porta OpenERP: ')
        self.file_dir = str(raw_input('Diretorio completo do arquivo: '))
        self.connection, self.uid = self.new_connection()

    def new_connection(self):
        """
        O metodo estabalece a conexao com o OpenERP.
        :return: objeto da conexao e id do usuario logado.
        :rtype: object
        """
        try:
            sock_common = xmlrpclib.ServerProxy('http://' + self.host + ':' + self.door +
                                                '/xmlrpc/common')
            socket.setdefaulttimeout(5)
            uid = sock_common.login(self.database, self.user, self.password)
            sock = xmlrpclib.ServerProxy('http://' + self.host + ':' + self.door + '/xmlrpc/object')
            return sock, uid
        except Exception as e:
            print str(e) + '\nNao foi possivel conectar ao OpenERP.'


class Product(object):
    def __init__(self):
        pass

    def get_product_id(self, barcode, conn):
        product_ids = conn.connection.execute(conn.database, conn.uid, conn.password,
                                              'automacao.codigo.barra', 'search',
                                              [('codigo_barra', '=', barcode)])
        if not product_ids:
            return False
        product_data = conn.connection.execute(conn.database, conn.uid, conn.password,
                                               'automacao.codigo.barra', 'read', product_ids[0],
                                               ['produto_id'])
        product_id = product_data.get('produto_id')[0]
        return product_id

    def create_price(self, product_id, price, conn):
        values = {'produto_id': product_id, 'preco_venda': price}
        sale_price_id = conn.connection.execute(conn.database, conn.uid, conn.password,
                                                'estoque.preco.venda', 'create', values,
                                                {'cadastro_produto': True})
        return sale_price_id


if __name__ == '__main__':
    conn = Connection()
    product = Product()
    file_open = open(conn.file_dir, 'r')
    file_data = file_open.readlines()
    not_found_products = ''
    product_count = 0
    for data in file_data:
        data = sub('[^0-9]', '', data)
        barcode = data[:14]
        print barcode
        price = float(data[14:]) / 100
        product_id = product.get_product_id(barcode, conn)
        if not product_id:
            not_found_products += data + '\n'
            continue
        product.create_price(product_id, price, conn)
        product_count += 1
    print 'ATUALIZACAO CONCLUIDA COM SUCESSO! %s PRECOS DE VENDA CRIADOS.' % product_count
    if not_found_products:
        not_found_products_file = open('/tmp/codigo_barra_nao_encontrado.txt', 'w')
        not_found_products_file.write(not_found_products)
        not_found_products_file.close()
        print "Os codigos de barras nao encontrados estao descritos no diretorio/arquivo: " \
              "'/tmp/codigo_barra_nao_encontrado.txt'."
    file_open.close()
