# -*- coding: utf-8 -*-

import psycopg2
import psycopg2.extras
##### Este Script ajusta os itens que tiveram desconto ou acrescimos em que o rateio ficou errado ###

def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results

print 'Iforme os seguintes dados'
erp_host = raw_input('Ip do ERP: ')
erp_usuario = raw_input('Usuario do postgres ERP: ')
erp_nome = raw_input('Nome do Banco ERP: ')
erp_senha = raw_input('Senha do Banco ERP: ')
data_init = raw_input('Data inicial(DD-MM-AAAA):').split('-')
data_init = data_init[2] + '-' + data_init[1] + '-' + data_init[0]
cont = 0
try:
    print '>>>>>> Alterando notas......\n'
    conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host, password=erp_senha,
                            connect_timeout=3)
    cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    try:
        cr.execute("""
                    SELECT fnc.id AS nf_id,
                           fnc.vr_total_nf - SUM(emi.vr_total_item_rateado) AS dif
                    FROM estoque_movimento_itens AS emi 
                    INNER JOIN fiscal_nf_capa AS fnc ON fnc.id = emi.nf_id
                    WHERE data_emissao >= '{inicio} 00:00:00'
                      AND state = '3'
                      AND tipo = 'S'
                      AND fisnfc_consumidor = True
                      
                    GROUP BY fnc.id, fnc.vr_total_nf
                    HAVING fnc.vr_total_nf - SUM(emi.vr_total_item_rateado) <> 0
                    ORDER BY fnc.id
                    """.format(inicio=data_init))
        dict_dados = {}
        nf_ids = []
        for i in dictfetchall(cr):
            nf_ids.append('%s' % i.get('nf_id'))
            dict_dados[i.get('nf_id')] = i.get('dif')

        if not nf_ids:
            raise Exception("Nenuma nota encontrada para data selecionada!")

        cr.execute("""SELECT id, 
                             nf_id,
                             vr_despesas_rateado               AS acrescimo_rat, 
                             vr_desconto_rateado               AS desconto_rat,
                             estmvi_vr_despesas_extras_rateado AS acrescimo, 
                             vr_desconto                       AS desconto,
                             vr_total_item_rateado             AS total_rateado
                      FROM estoque_movimento_itens 
                      WHERE nf_id IN ({nf_ids})
                   """.format(nf_ids=','.join(nf_ids)))
        dict_itens = {}
        for i in dictfetchall(cr):
            if not dict_itens.get(i.get('nf_id')):
                dict_itens[i.get('nf_id')] = [i]
            else:
                dict_itens[i.get('nf_id')].append(i)

        for nf_id, dif in dict_dados.items():
            maior_item = False
            for item in dict_itens.get(nf_id):
                if not maior_item or item.get('acrescimo_rat') > maior_item.get('acrescimo_rat') or \
                                    item.get('desconto_rat') > maior_item.get('desconto_rat') or \
                                    item.get('acrescimo') > maior_item.get('acrescimo') or \
                                    item.get('desconto') > maior_item.get('desconto'):
                    maior_item = item

            campo = ''
            valor = 0
            maior_item['total_rateado'] += dif
            if maior_item.get('acrescimo_rat'):
                maior_item['acrescimo_rat'] += dif
                valor = maior_item.get('acrescimo_rat')
                campo = 'vr_despesas_rateado'

            elif maior_item.get('desconto_rat'):
                maior_item['desconto_rat'] += dif * -1
                valor = maior_item.get('desconto_rat')
                campo = 'vr_desconto_rateado'

            elif maior_item.get('acrescimo'):
                maior_item['acrescimo'] += dif
                valor = maior_item.get('acrescimo')
                campo = 'estmvi_vr_despesas_extras_rateado'

            elif maior_item.get('desconto'):
                maior_item['desconto'] += dif * -1
                valor = maior_item.get('desconto')
                campo = 'vr_desconto'

            cr.execute("""UPDATE estoque_movimento_itens
                             SET vr_total_item_rateado = {total},
                                 {campo} = {valor}  
                          WHERE id = {id}""".format(id=maior_item.get('id'),
                                                    total=maior_item.get('total_rateado'),
                                                    campo=campo,
                                                    valor=valor))
            cont += 1
        cr.execute('COMMIT;')

    except Exception as e:
        print 'Erro ao atualizar notas: %s' % e

except Exception as e:
    print 'Erro: %s' % e

print 'Finalizado, %s notas alteradas' % cont
