# -*- coding: utf-8 -*-

import psycopg2
import psycopg2.extras


##### Este Script ajusta os modelos e series da nfces importadas de forma errada com multi-empresa ###

def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results


print 'Iforme os seguintes dados'
erp_host = raw_input('Ip do ERP: ')
erp_usuario = raw_input('Usuario do postgres ERP: ')
erp_nome = raw_input('Nome do Banco ERP: ')
erp_senha = raw_input('Senha do Banco ERP: ')
cont = 0
try:
    print '>>>>>> Alterando notas......\n'
    conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host, password=erp_senha,
                            connect_timeout=3)
    cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    try:
        cr.execute("""
                SELECT nf.id                AS nf_id, 
                       nf.numero_nf         AS numero_nf,
                       modelo.fismnf_codigo AS modelo,
                       nf.modelo_nf_id      AS modelo_id, 
                       serie.id             AS serie_id,
                       nf.serie_nf          AS nf_serie,
                       serie.serie_nf       AS serie_serie,
                       nf.company_id        AS nota_company_id,
                       par.company_id       AS par_company_id
                FROM fiscal_nf_capa                AS nf
                INNER JOIN fiscal_modelo_nf_series AS serie ON serie.id = nf.modelo_nf_series_id
                INNER JOIN fiscal_modelo_nf        AS modelo ON modelo.id = nf.modelo_nf_id
                INNER JOIN fiscal_parametro        AS par ON par.id = serie.parametro_id
                WHERE nf.company_id <> par.company_id
                order by nf.company_id, nf.modelo_nf_id, nf.serie_nf, nf.numero_nf
                    """)
        dados_nf = dictfetchall(cr)

        if not dados_nf:
            raise Exception("Nenuma nota com modelo e serie incorretos!")

        cr.execute("""
                SELECT serie.serie_nf AS serie,
                       serie.id       AS serie_id,
                       modelo.fismnf_codigo AS modelo,
                       modelo.id            AS modelo_id,
                       par.company_id
                FROM fiscal_modelo_nf_series AS serie
                INNER JOIN fiscal_modelo_nf  AS modelo ON modelo.id = serie.modelo_nf_id
                INNER JOIN fiscal_parametro  AS par    ON par.id = serie.parametro_id
                WHERE modelo.fismnf_codigo IN ('65', '91')
                order by par.company_id
                   """)
        dict_modelos = {}
        map(lambda x: dict_modelos.update({'%s-%s-%s' % (x.get('serie'),
                                                         x.get('modelo_id'),
                                                         x.get('company_id')): x}), dictfetchall(cr))

        msg = []
        controle_chaves = []
        dados_update = {}
        for nf in dados_nf:
            chave = '%s-%s-%s' % (nf.get('serie_serie'),
                                  nf.get('modelo_id'),
                                  nf.get('nota_company_id'))
            if chave not in dict_modelos:
                if chave not in controle_chaves:
                    msg.append('Empresa %s sem Série %s e Modelo %s cadastrados no '
                               'parâmetro do Fiscal!' % (nf.get('nota_company_id'),
                                                         nf.get('serie_serie'),
                                                         nf.get('modelo')))
                    controle_chaves.append(chave)
                continue
            else:
                if not dados_update.get(chave):
                    dados_update[chave] = ['%s' % nf.get('nf_id')]
                else:
                    dados_update[chave].append('%s' % nf.get('nf_id'))

        if msg:
            raise Exception('\n'+'\n'.join(msg))

        for chave, nf_ids in dados_update.items():
            dados_modelo = dict_modelos.get(chave)
            if not dados_modelo:
                continue

            cr.execute("""UPDATE fiscal_nf_capa 
                             SET modelo_nf_series_id = {serie_id},
                                 modelo_nf_id = {modelo_id} 
                           WHERE id IN ({nf_ids}); 
                       """.format(serie_id=dados_modelo.get('serie_id'),
                                  modelo_id=dados_modelo.get('modelo_id'),
                                  nf_ids=','.join(nf_ids)))
            cont += len(nf_ids)

        cr.execute('COMMIT;')
        print 'Finalizado, %s notas alteradas' % cont
    except Exception as e:
        print 'Erro ao atualizar notas: %s' % e

except Exception as e:
    print 'Erro: %s' % e

