# -*- coding: utf-8 -*-

import psycopg2
import psycopg2.extras
from datetime import datetime, timedelta
import pytz


def converte_tz(data, tz_origem, tz_destino):
    """
    Função para converter data de um timezone para outro
    @param data: data no formato datetime para ser convertida
    @param tz_origem: Timezone em que a data se encontra. Se None, vai buscar timezone do usuário
    @param tz_destino: Timezne em que a data será convertida. Se None, vai buscar timezone do usuário
    @return: data no formato datetime convertida para o novo timezone
    """
    obj_origem = pytz.timezone(tz_origem)
    obj_destino = pytz.timezone(tz_destino)
    x = obj_origem.localize(data, is_dst=False)
    return x.astimezone(obj_destino)

print 'Iforme os seguintes dados'
host = raw_input('Ip do caixa: ')
banco = raw_input('Nome do Banco: ')
porta = '5432'
usuario = 'postgres'
senha = raw_input('Senha do postgres: ')
horas = raw_input('Número de horas: ')
try:
    print '>>>>>> Criando contingencia......\n'
    conn = psycopg2.connect(database=banco, user=usuario, host=host, password=senha,
                            connect_timeout=5)
    _cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    try:
        data = converte_tz(datetime.now(), 'America/Sao_Paulo', 'UTC')
        data_inicio = str(data)
        data_fim = str(data + timedelta(hours=int(horas)))
        if data_inicio > data_fim:
            data_inicio = data_fim

        if horas == '0':
            data_inicio = data_fim = ''

        _cr.execute("""UPDATE caixa_cfg_configuracao 
                       SET supcfc_incio_contingencia = {inicio},
                           supcfc_fim_contingencia = {fim};
                       COMMIT;                 
                    """.format(inicio=data_inicio and "'%s'" % data_inicio[:19] or 'null',
                               fim=data_fim and "'%s'" % data_fim[:19] or 'null'))

        print 'Finalizado!'
    except Exception as e:
        print 'Erro ao atualizar a base:%s' % e

except Exception as e:
    print 'Erro ao atualizar a base:%s' % e