# -*- coding: utf-8 -*-

# Script para ajustar o campo modelo_nf_series_id das notas que estao em uma empresa
# e o modelo esta cadastrado em outra empresa.

import os
import psycopg2
import psycopg2.extras


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results

print 'Iforme os seguintes dados'
sup_host = raw_input('Ip do ERP: ')
sup_usuario = raw_input('Usuario do postgres: ')
sup_nome = raw_input('Nome do Banco: ')
sup_senha = raw_input('Senha do Banco: ')

try:
    print '>>>>>> Alterando notas......\n'
    conn_s = psycopg2.connect(database=sup_nome, user=sup_usuario, host=sup_host,
                              connect_timeout=5, password=sup_senha)
    cr = conn_s.cursor(cursor_factory=psycopg2.extras.DictCursor)
    try:
        cont = 0
        cr.execute("""
            SELECT par.company_id       AS parametro_company_id,
                   serie.id             AS serie_id,
                   serie.serie_nf,
                   serie.ambiente,
                   modelo.fismnf_codigo AS codigo_modelo
                   
            FROM fiscal_modelo_nf_series AS serie
            INNER JOIN fiscal_modelo_nf  AS modelo  ON modelo.id = serie.modelo_nf_id 
            INNER JOIN fiscal_parametro  AS par     ON par.id = serie.parametro_id 
            order by par.company_id, modelo.fismnf_codigo
        """)
        dict_par = {}
        for i in dictfetchall(cr):
            chave = '%s-%s-%s-%s' % (i.get('parametro_company_id'),
                                     i.get('serie_nf'),
                                     i.get('ambiente'),
                                     i.get('codigo_modelo'),)
            dict_par.update({chave: i.get('serie_id')})

        cr.execute("""SELECT capa.id,
                             capa.company_id AS nota_company_id,
                             serie.serie_nf,
                             serie.ambiente,
                             modelo.fismnf_codigo AS codigo_modelo
                             
                      FROM fiscal_nf_capa                AS capa
                      INNER JOIN fiscal_modelo_nf_series AS serie  ON serie.id = capa.modelo_nf_series_id
                      INNER JOIN fiscal_modelo_nf        AS modelo ON modelo.id = serie.modelo_nf_id 
                      INNER JOIN fiscal_parametro        AS par    ON par.id = serie.parametro_id 
                      WHERE capa.company_id <> par.company_id
        """)
        msg = []
        for nota in dictfetchall(cr):
            chave = '%s-%s-%s-%s' % (nota.get('nota_company_id'),
                                     nota.get('serie_nf'),
                                     nota.get('ambiente'),
                                     nota.get('codigo_modelo'))
            if not dict_par.get(chave):
                mensagem = 'Empresa: %s Serie: %s Modelo: %s Ambiente: %s' % \
                                          (nota.get('nota_company_id'),
                                           nota.get('serie_nf'),
                                           nota.get('codigo_modelo'),
                                           {1: 'Producao',
                                            2: 'Homologacao'}.get(nota.get('ambiente')))
                if mensagem not in msg:
                    msg.append(mensagem)

                continue

            cont += 1
            cr.execute("""UPDATE fiscal_nf_capa 
                             SET modelo_nf_series_id = %s 
                             WHERE id = %s""" % (dict_par.get(chave),
                                                 nota.get('id'))
                       )

        cr.execute('COMMIT;')
        print 'Fim da atualização, %s nostas atualizadas' % (cont)
        if msg:
            print 'Sem parametros para:\n %s' % '\n'.join(msg)

    except Exception as e:
        print 'Erro ao atualizar notas: %s' % e

except Exception as e:
    print 'Erro ao conectar no banco informado: %s' % e

