# -*- coding: utf-8 -*-

# Este script Altera o campo 'data_emissao' das notas com a data na chave de acesso em um mes e o campo
# 'data_emissao' em outro mes, coloca o valor de 'create_date' em 'data_emissao'


import psycopg2.extras


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results


class get_browse(object):
    def __init__(self, d):
        for a, b in d.items():
            if isinstance(b, (list, tuple)):
                setattr(self, a, [get_browse(x) if isinstance(x, dict) else x for x in b])
            else:
                setattr(self, a, get_browse(b) if isinstance(b, dict) else b)


print 'Iforme os seguintes dados'
erp_host = raw_input('Ip do ERP: ')
erp_usuario = raw_input('Usuario do postgres ERP: ')
erp_nome = raw_input('Nome do Banco ERP: ')
erp_senha = raw_input('Senha do Banco ERP: ')

cont = 0
msg = []
try:
    print '>>>>>> Alterando nota......\n'
    conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host,
                            password=erp_senha, connect_timeout=20)
    cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    try:
        cr.execute("""SELECT id, 
                             create_date,
                             nfe_chave_acesso,
                             serie_nf, 
                             numero_nf
                       FROM fiscal_nf_capa
                       WHERE data_emissao >= '2021-08-01'
                         AND data_emissao <= '2021-08-31'
                         AND nfe_forma_emissao = '2'
                         AND state IN ('3', 'P')
                         AND fisnfc_consumidor = True
                         AND nfe_xml_auto IS NULL
                        """)
        dados_nf = dictfetchall(cr)
        if not dados_nf:
            raise Exception("Não foi encontrada nenhuma Nota")

        for i in dados_nf:
            brw_capa = get_browse(i)
            if brw_capa.nfe_chave_acesso[4:6] != ('%02d' % brw_capa.create_date.month):
                cr.execute("""UPDATE fiscal_nf_capa
                                 SET data_emissao = '{data}'
                              WHERE id = {id}
                              COMMIT;
                              """.format(data=brw_capa.create_date,
                                         id=brw_capa.id))
                msg.append('%s-%s' % (brw_capa.numero_nf, brw_capa.serie_nf))

            cont += 1

        print 'Finalizado, %s notas atualizadas' % cont
        if msg:
            print 'Notas alteradas (Numero-Serie):\n%s' % '\n'.join(msg)

    except Exception as e:
        print 'Erro ao atualizar notas: %s' % e

except Exception as e:
    print 'Erro ao conectar com a Base de dados:%s' % e
