# -*- coding: utf-8 -*-

#################################### DESCRIÇÃO DO SCRIPT #####################################
# Este script altera os corpos das notas com erro ou contingencia que foram cridas no caixa na
# versão 9J e o supervisor está na 20B

import psycopg2.extras


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results



print 'Iforme os seguintes dados'
erp_host = raw_input('Ip do ERP: ')
erp_usuario = raw_input('Usuario do postgres ERP: ')
erp_nome = raw_input('Nome do Banco ERP: ')
erp_senha = raw_input('Senha do Banco ERP: ')

try:
    print '>>>>>> Alterando notas......\n'
    conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host, password=erp_senha,
                            connect_timeout=30)
    cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    notas = []
    try:
        cr.execute("""SELECT capa.id AS capa_id,
                             corpo.id AS corpo_id,
                             item.supite_codigo_retaguarda,
                             item.supite_codigo_anp,
                             item.supite_producao,
                             item.supite_origem_mercadoria,
                             item.supite_aliquota_ibpt_fed,
                             item.supite_aliquota_ibpt_est,
                             item.supite_aliquota_ibpt_mun,
                             item.supite_getin,
                             icms.suptnf_codigo_cst AS cst_icms,
                             icms.suptnf_tipo_tributacao,
                             icms.suptnf_codigo_csosn,
                             COALESCE(icms.suptnf_aliquota, 0) AS aliquota_icms,
                             icms.suptnf_codigo_beneficio,
                             icms.suptnf_motivo_beneficio,
                             COALESCE(icms.suptnf_aliquota_fcp, 0),
                             COALESCE(pis.suptnf_aliquota, 0) AS aliquota_pis,
                             pis.suptnf_codigo_cst AS cst_pis,
                             COALESCE(cofins.suptnf_aliquota, 0) AS aliquota_cofins,
                             cofins.suptnf_codigo_cst AS cst_cofins
                      FROM supervisor_mov_capa                  AS capa
                      INNER JOIN supervisor_mov_corpos          AS corpo  ON corpo.supcor_capa_id = capa.id
                      INNER JOIN supervisor_cad_itens           AS item   ON item.supite_codigo_item = corpo.supcor_item
                      INNER JOIN supervisor_cad_tributacao_nfce AS icms   ON icms.suptnf_codigo = item.supite_tributacao_icms_id
                      INNER JOIN supervisor_cad_tributacao_nfce AS pis    ON pis.suptnf_codigo = item.supite_tributacao_pis_id
                      INNER JOIN supervisor_cad_tributacao_nfce AS cofins ON cofins.suptnf_codigo = item.supite_tributacao_cofins_id
                      WHERE capa.supcap_state IN ('4', '2E')
                        AND corpo.supcor_codigo_retaguarda IS NULL
                      ORDER BY supcap_nro_cupom""")
        vals_update = []
        for i in dictfetchall(cr):
            if i.get('capa_id') not in notas:
                notas.append(i.get('capa_id'))
            vals_update.append("""SELECT {corpo_id}                      AS corpo_id,
                                        '{supcor_codigo_retaguarda}'     AS supcor_codigo_retaguarda,
                                        {supcor_codigo_anp}              AS supcor_codigo_anp,
                                        '{supcor_producao}'              AS supcor_producao,
                                        '{supcor_origem_mercadoria}'     AS supcor_origem_mercadoria,
                                         {supcor_aliquota_ibpt_fed}      AS supcor_aliquota_ibpt_fed,
                                         {supcor_aliquota_ibpt_est}      AS supcor_aliquota_ibpt_est,
                                         {supcor_aliquota_ibpt_mun}      AS supcor_aliquota_ibpt_mun,
                                         {supcor_getin}                  AS supcor_getin,
                                        '{supcor_codigo_cst_icms}'       AS supcor_codigo_cst_icms,
                                        '{supcor_tipo_tributacao_icms}'  AS supcor_tipo_tributacao_icms,
                                        '{supcor_codigo_csosn_icms}'     AS supcor_codigo_csosn_icms,
                                         {supcor_aliquota_icms}          AS supcor_aliquota_icms,
                                        '{supcor_codigo_beneficio_icms}' AS supcor_codigo_beneficio_icms,
                                        '{supcor_motivo_beneficio_icms}' AS supcor_motivo_beneficio_icms,
                                         {supcor_aliquota_fcp_icms}      AS supcor_aliquota_fcp_icms,
                                         {supcor_aliquota_pis}           AS supcor_aliquota_pis,
                                        '{supcor_codigo_cst_pis}'        AS supcor_codigo_cst_pis,
                                         {supcor_aliquota_cofins}        AS supcor_aliquota_cofins,
                                        '{supcor_codigo_cst_cofins}'     AS supcor_codigo_cst_cofins
                               """.format(corpo_id=i.get('corpo_id'),
                                          supcor_codigo_retaguarda=i.get('supite_codigo_retaguarda'),
                                          supcor_codigo_anp=i.get('supite_codigo_anp') or 0,
                                          supcor_producao=i.get('supite_producao') or 'T',
                                          supcor_origem_mercadoria=i.get('supite_origem_mercadoria') or '0',
                                          supcor_aliquota_ibpt_fed=i.get('supite_aliquota_ibpt_fed') or 0,
                                          supcor_aliquota_ibpt_est=i.get('supite_aliquota_ibpt_est') or 0,
                                          supcor_aliquota_ibpt_mun=i.get('supite_aliquota_ibpt_mun') or 0,
                                          supcor_getin=i.get('supite_getin'),
                                          supcor_codigo_cst_icms=i.get('cst_icms'),
                                          supcor_tipo_tributacao_icms=i.get('suptnf_tipo_tributacao').replace(' ', ''),
                                          supcor_codigo_csosn_icms=i.get('suptnf_codigo_csosn') or '',
                                          supcor_aliquota_icms=i.get('aliquota_icms') or 0,
                                          supcor_codigo_beneficio_icms=(i.get('suptnf_codigo_beneficio') or ''),
                                          supcor_motivo_beneficio_icms=(i.get('suptnf_motivo_beneficio') or '').replace(' ', ''),
                                          supcor_aliquota_fcp_icms=i.get('suptnf_aliquota_fcp') or 0,
                                          supcor_aliquota_pis=i.get('aliquota_pis') or 0,
                                          supcor_codigo_cst_pis=i.get('cst_pis'),
                                          supcor_aliquota_cofins=i.get('aliquota_cofins') or 0,
                                          supcor_codigo_cst_cofins=i.get('cst_cofins')
                                          ))
        cr.execute("""UPDATE supervisor_mov_corpos corpos
                         SET supcor_codigo_retaguarda=tmp.supcor_codigo_retaguarda,
                             supcor_codigo_anp=tmp.supcor_codigo_anp,
                             supcor_producao=tmp.supcor_producao,
                             supcor_origem_mercadoria=tmp.supcor_origem_mercadoria,
                             supcor_aliquota_ibpt_fed=tmp.supcor_aliquota_ibpt_fed,
                             supcor_aliquota_ibpt_est=tmp.supcor_aliquota_ibpt_est,
                             supcor_aliquota_ibpt_mun=tmp.supcor_aliquota_ibpt_mun,
                             supcor_getin=tmp.supcor_getin,
                             supcor_codigo_cst_icms=tmp.supcor_codigo_cst_icms,
                             supcor_tipo_tributacao_icms=tmp.supcor_tipo_tributacao_icms,
                             supcor_codigo_csosn_icms=tmp.supcor_codigo_csosn_icms,
                             supcor_aliquota_icms=tmp.supcor_aliquota_icms,
                             supcor_codigo_beneficio_icms=tmp.supcor_codigo_beneficio_icms,
                             supcor_motivo_beneficio_icms=tmp.supcor_motivo_beneficio_icms,
                             supcor_aliquota_fcp_icms=tmp.supcor_aliquota_fcp_icms,
                             supcor_aliquota_pis=tmp.supcor_aliquota_pis,
                             supcor_codigo_cst_pis=tmp.supcor_codigo_cst_pis,
                             supcor_aliquota_cofins=tmp.supcor_aliquota_cofins,
                             supcor_codigo_cst_cofins=tmp.supcor_codigo_cst_cofins
                             
                      FROM (%s) AS tmp
                      WHERE corpos.id = tmp.corpo_id;
                      COMMIT;""" % '\nUNION ALL\n'.join(vals_update))
        print 'Finalizado!\n%s notas alteradas\n%s corpos alteradas' % (len(notas), len(vals_update))

    except Exception as e:
        print 'Erro ao atualizar notas: %s' % e

except Exception as e:
    print 'Erro ao atualizar a base:%s' % e

