# -*- coding: utf-8 -*-

#################################### DESCRIÇÃO DO SCRIPT #####################################
# Ajusta o desconto ou acrescimo na capa da nota no ERP, com os repectivos valores
# encontrados no supervisor

import psycopg2.extras


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results



print 'Iforme os seguintes dados'
erp_host = raw_input('Ip do ERP: ')
erp_usuario = raw_input('Usuario do postgres ERP: ')
erp_nome = raw_input('Nome do Banco ERP: ')
erp_senha = raw_input('Senha do Banco ERP: ')
flag =  raw_input('Supervisor está no mesmo banco do ERP?(S/N) ')

if flag.upper() == 'N':
    sup_host = raw_input('Ip do Supervisor: ')
    sup_usuario = raw_input('Usuario do postgres Supervisor: ')
    sup_nome = raw_input('Nome do Banco Supervisor: ')

try:
    print '>>>>>> Alterando notas......\n'
    cont = 0
    conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host, password=erp_senha,
                            connect_timeout=30)
    cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    _cr = cr
    if flag.upper() == 'N': # banco supervisor em outra maquina
        conn_s = psycopg2.connect(database=sup_nome, user=sup_usuario, host=sup_host, connect_timeout=3)
        _cr = conn_s.cursor(cursor_factory=psycopg2.extras.DictCursor)

    notas = []
    try:
        _cr.execute("SELECT supcfc_nro_empresa FROM supervisor_cfg_configuracao")
        config_sup = dictfetchall(_cr)
        if not config_sup:
            raise Exception('Supervisor está sem configuração cadastrada!')

        config_sup = config_sup[0]
        if not config_sup.get('supcfc_nro_empresa'):
            raise Exception('Supervisor está sem EMPRESA cadastrada nas configurações!')

        cr.execute("""
                SELECT * 
                FROM (SELECT capa.id,
                             capa.numero_nf, 
                             capa.serie_nf, 
                             capa.vr_total_nf,
                             capa.company_id,
                             (capa.vr_icms_substituicao + 
                              capa.vr_ipi + 
                              capa.fisnfc_valor_fcp_st - 
                              capa.fisnfc_valor_icms_desonerado + 
                              sum(item.vr_total_item_rateado)) AS tot_item,
                             (capa.vr_total_nf - (capa.vr_icms_substituicao +
                                                  capa.vr_ipi + 
                                                  capa.fisnfc_valor_fcp_st - 
                                                  capa.fisnfc_valor_icms_desonerado + 
                                                  SUM(item.vr_total_item_rateado))
                                             ) AS dif
                    FROM fiscal_nf_capa                AS capa
                    INNER JOIN estoque_movimento_itens AS item on item.nf_id = capa.id
                    WHERE tipo = 'S'
                      AND state = '3'
                      AND vr_total_item_rateado > 0
                      AND modelo_nf_series_id = 7
                    GROUP by capa.id, capa.numero_nf, capa.serie_nf, capa.company_id, capa.vr_total_nf, 
                          capa.vr_icms_substituicao, capa.vr_ipi, capa.fisnfc_valor_fcp_st, 
                          capa.fisnfc_valor_icms_desonerado) AS tmp
                WHERE dif <> 0
                    """)
        dados = dictfetchall(cr)
        if not dados:
            raise Exception('Nenhuma nota encontrada!', 123)

        cond = []
        company_ids = []
        dict_notas = {}
        for i in dados:
            if i.get('company_id') != config_sup.get('supcfc_nro_empresa'):
                continue

            company_ids.append(i.get('company_id'))
            cond.append('(supcap_nro_cupom = %s AND supcap_caixa = %s AND supcap_state IS NOT NULL)'
                        % (i.get('numero_nf'), i.get('serie_nf')))
            chave = '%s-%s' % (i.get('numero_nf'), i.get('serie_nf'))
            dict_notas[chave] = i

        if not company_ids:
            raise Exception('As notas encontradas no ERP não são da mesma empresa do Supervisor!')

        _cr.execute("""SELECT supcap_nro_cupom        AS numero,
                              supcap_caixa            AS serie,
                              supcap_alteracao        AS tipo,
                              supcap_valor_desc_acres AS valor
                       FROM supervisor_mov_capa 
                       WHERE %s                       
                    """ % '\n        OR'.join(cond))
        cond_update = []
        alteradas = []
        for i in dictfetchall(_cr):
            cont += 1
            chave = '%s-%s' % (i.get('numero'), i.get('serie'))
            nota = dict_notas.get(chave)
            alteradas.append('%s - %s' % (chave, nota.get('company_id')))
            desconto = acrescimo = 0
            if i.get('tipo') == 'D':
                desconto = i.get('valor') or 0
            else:
                acrescimo = i.get('valor') or 0

            cond_update.append("""SELECT {id}        AS id,
                                         {desconto}  AS vr_desconto,
                                         {acrescimo} AS vr_despesas_acessorias
                               """.format(id=nota.get('id'),
                                          desconto=desconto,
                                          acrescimo=acrescimo))
        if cond_update:
            cr.execute("""
            UPDATE fiscal_nf_capa capa
            SET vr_desconto = tmp.vr_desconto,
                vr_despesas_acessorias = tmp.vr_despesas_acessorias
            FROM (%s) AS tmp
            WHERE capa.id = tmp.id;
            COMMIT;""" % '\nUNION ALL\n'.join(cond_update))

        alteradas.sort()
        print 'Finalizado!\n%s notas alteradas\nNúmero-Série - Empresa\n%s' % (cont, '\n'.join(alteradas))

    except Exception as e:
        if e.args and len(e.args) > 1 and e.args[1] == 123:
            print e.message
        else:
            print 'Erro ao atualizar notas: %s' % e

except Exception as e:
    print 'Erro ao conectar com o banco: %s' % e

