# -*- coding: utf-8 -*-

# Este script copia o xml do Supervisor do o campo xml_auto para o ERP


import psycopg2.extras


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results


class get_browse(object):
    def __init__(self, d):
        for a, b in d.items():
            if isinstance(b, (list, tuple)):
                setattr(self, a, [get_browse(x) if isinstance(x, dict) else x for x in b])
            else:
                setattr(self, a, get_browse(b) if isinstance(b, dict) else b)

print 'Iforme os seguintes dados'
erp_host = sup_host = raw_input('Ip do ERP: ')
erp_usuario = sup_usuario = raw_input('Usuario do postgres ERP: ')
erp_nome = sup_nome = raw_input('Nome do Banco ERP: ')
erp_senha = sup_senha = raw_input('Senha do Banco ERP: ')
juntos = ''
while juntos.upper() not in ('S', 'N'):
    juntos = raw_input('O banco do ERP é o mesmo do Supervisor?(S/N): ')
    if juntos.upper() not in ('S', 'N'):
        print 'Valor incorreto, deve ser "S" ou "N"!'

if juntos.upper() == 'N':
    sup_host = raw_input('Ip do SUPERVISOR: ')
    sup_usuario = raw_input('Usuario do postgres SUPERVISOR: ')
    sup_nome = raw_input('Nome do Banco SUPERVISOR: ')
    sup_senha = raw_input('Senha do Banco SUPERVISOR: ')

try:
    print '>>>>>> Alterando nota......\n'
    conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host,
                            password=erp_senha, connect_timeout=20)
    cr = _cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    if juntos.upper() == 'N':
        conn = psycopg2.connect(database=sup_nome, user=sup_usuario, host=sup_host,
                                password=sup_senha, connect_timeout=20)
        _cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    try:
        dict_sup = {}
        cr.execute("""
                    SELECT numero_nf, serie_nf, company_id 
                    FROM fiscal_nf_capa  as capa
                    LEFT JOIN fiscal_modelo_nf AS modelo ON modelo.id = capa.modelo_nf_id
                    WHERE nfe_xml_auto = '*'
                      AND state = '3'
                      AND tipo = 'S'
                      AND modelo.fismnf_codigo = '65'
                    ORDER BY company_id, numero_nf""")
        cond = []
        dict_cond = {}
        company_id = False
        for i in dictfetchall(cr):
            if company_id != i.get('company_id'):
                if company_id:
                    if cond:
                        dict_cond[company_id].extend(cond)
                        cond = []

                company_id = i.get('company_id')
                if not company_id in dict_cond:
                    dict_cond[company_id] = []

            cond.append('(supcap_nro_cupom = %s AND supcap_caixa = %s)' %
                        (i.get('numero_nf'), i.get('serie_nf')))

        if cond:
            dict_cond[company_id].extend(cond)


        encontrou_empresa = False
        company_ids = []
        dict_notas = {}
        for company_id, cond in dict_cond.items():
            _cr.execute("""SELECT 
                           FROM supervisor_cfg_configuracao 
                           WHERE supcfc_nro_empresa = %s 
                        """ % company_id)
            if not dictfetchall(_cr):
                company_ids.append('%s' % company_id)
                continue

            encontrou_empresa = True
            _cr.execute("""SELECT supcap_nro_cupom, supcap_caixa, supcap_xml_proc, supcap_data_inicio
                           FROM supervisor_mov_capa
                           WHERE {cond}
                             AND supcap_xml_proc IS NOT NULL
                             AND supcap_state = '3'
                             AND supcap_tipo = 'V' """.format(cond='\nOR '.join(cond)))
            dados_nf = dictfetchall(_cr)
            if not dados_nf:
                raise Exception(
                    "Notas do ERP não estão no Supervisor da empresa %s" % company_id)

            if not dict_notas.get(company_id):
                dict_notas[company_id] = dados_nf
            else:
                dict_notas[company_id].extend(dados_nf)

        if not encontrou_empresa:
            raise Exception("Não encontrado SUPERVISOR para empresas %s" % ', '.join(company_ids))

        for company_id, notas in dict_notas.items():
            cont = 0
            msg = []
            for i in notas:
                cont += 1
                brw_capa = get_browse(i)
                try:
                    cr.execute("""
                UPDATE fiscal_nf_capa nfc1
                   SET nfe_xml_auto = '{xml}'
                FROM fiscal_nf_capa AS nfc2
                INNER JOIN fiscal_modelo_nf AS modelo ON modelo.id = nfc2.modelo_nf_id
                INNER JOIN fiscal_modelo_nf_series AS serie ON serie.id = nfc2.modelo_nf_series_id 
                WHERE nfc2.numero_nf = {numero}
                  AND nfc2.serie_nf = '{serie}'
                  AND nfc2.data_emissao = '{data}'
                  AND nfc2.nfe_xml_auto = '*'
                  AND nfc2.state = '3'
                  AND nfc2.company_id = {company_id}
                  AND modelo.fismnf_codigo = '65'
                  AND nfc1.id = nfc2.id;
                COMMIT;
                """.format(numero=brw_capa.supcap_nro_cupom,
                           serie=brw_capa.supcap_caixa,
                           data=str(brw_capa.supcap_data_inicio)[:19],
                           xml=brw_capa.supcap_xml_proc,
                           company_id=company_id))
                    msg.append('%s-%s' % (brw_capa.supcap_nro_cupom, brw_capa.supcap_caixa))
                except Exception as e:
                    print 'Erro ao atualizar nota %s-%s: %s' % (brw_capa.supcap_nro_cupom,
                                                                brw_capa.supcap_caixa, e)
            if msg:
                print '%s Notas da empresa %s atualizadas: Número - Série\n%s' % (cont,
                                                                                  company_id,
                                                                                  '\n'.join(msg))

    except Exception as e:
        print 'Erro ao atualizar notas: %s' % e

except Exception as e:
    print 'Erro ao conectar com a Base de dados:%s' % e
