# -*- coding: utf-8 -*-

# Este script copia a comissao do movimento dos itens de cupons para os itens das notas de devolução


import psycopg2.extras


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results


class get_browse(object):
    def __init__(self, d):
        for a, b in d.items():
            if isinstance(b, (list, tuple)):
                setattr(self, a, [get_browse(x) if isinstance(x, dict) else x for x in b])
            else:
                setattr(self, a, get_browse(b) if isinstance(b, dict) else b)

print 'Iforme os seguintes dados'
erp_host = raw_input('Ip do ERP: ')
erp_usuario = raw_input('Usuario do postgres ERP: ')
erp_nome = raw_input('Nome do Banco ERP: ')
erp_senha = raw_input('Senha do Banco ERP: ')

try:
    print '>>>>>> Alterando notas......\n'
    conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host,
                            password=erp_senha, connect_timeout=20)
    cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    try:
        dict_sup = {}
        cr.execute("""        
            SELECT emic.vendedor_id, 
                   emif.id, 
                   emif.sequencia,
                   fnc.id AS nf_id, 
                   fnc.numero_nf, 
                   fnc.serie_nf,
                   fnc.company_id
            FROM estoque_movimento_itens       AS emic
            INNER JOIN ecf_cupons_capa         AS ecc  ON ecc.id = emic.cupom_id
            INNER JOIN fiscal_nf_capa          AS fnc  ON fnc.id = ecc.fisnfc_nf_referencia_id 
            INNER JOIN estoque_movimento_itens AS emif ON emif.nf_id = fnc.id 
                                                      AND emif.grade_id = emic.grade_id
            WHERE ecc.date_cupom >= '2020-04-01'
              AND emic.estmvi_vr_comissao > 0 
              AND emic.vendedor_id IS NOT NULL
              AND emif.vendedor_id IS NULL
              AND fnc.tipo = 'E'
                    """)
        dados = dictfetchall(cr)
        if not dados:
            raise Exception('Nenhuma nota com erro encontrada!')

        nf_ids = []
        msg = []
        cont = 0
        for i in dados:
            try:
                cr.execute("""UPDATE estoque_movimento_itens
                              SET vendedor_id = {vendedor_id}
                              WHERE id = {id}
                           """.format(vendedor_id=i.get('vendedor_id'),
                                      id=i.get('id')))
                cont += 1
                if i.get('nf_id') not in nf_ids:
                    nf_ids.append(i.get('nf_if'))
            except Exception as e:
                msg.append('Empresa: %s Nota %s - %s, Item sequencia: %s. Erro: %s' %
                           (i.get('company_id'), i.get('numero_nf'),
                            i.get('serie_nf'), i.get('sequencia'), e))

        cr.execute('COMMIT;')
        if msg:
            print 'Erro:\n%s' % '\n'.join(msg)

        print 'Notas alteradas %s, Itens alterados: %s' % (len(nf_ids), cont)

    except Exception as e:
        print 'Erro ao atualizar notas: %s' % e

except Exception as e:
    print 'Erro ao conectar com a Base de dados:%s' % e
