# -*- coding: utf-8 -*-

# Este script deleta as NFC-e's que foram duplicadas no ERP pelo cron de importacao de NFC-e
# deixando apenas uma delas

import psycopg2
import psycopg2.extras


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results

print 'Iforme os seguintes dados'
sup_host = raw_input('Ip do ERP: ')
sup_usuario = raw_input('Usuario do postgres ERP: ')
sup_nome = raw_input('Nome do Banco ERP: ')
sup_senha = raw_input('Senha do Banco ERP: ')

try:
    print '>>>>>> Deletando notas Duplicadas......\n'
    conn = psycopg2.connect(database=sup_nome, user=sup_usuario, host=sup_host,
                            password=sup_senha, connect_timeout=20)
    _cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    try:
        _cr.execute('SELECT id FROM res_company ORDER BY id')
        cont = 0
        excluida_ids = []
        for company_id in dictfetchall(_cr):
            dict_sup = {}
            _cr.execute("""SELECT COUNT(fnc.numero_nf), 
                                        fnc.numero_nf, 
                                        fnc.serie_nf, 
                                        fnc.company_id,
                                        fnc.modelo_nf_id
                           FROM fiscal_nf_capa AS fnc
                           INNER JOIN fiscal_modelo_nf AS fmn ON fmn.id = fnc.modelo_nf_id
                           WHERE fnc.company_id = {company_id}
                             AND fmn.fismnf_codigo = '65'
                           GROUP BY fnc.numero_nf, fnc.serie_nf, fnc.company_id, fnc.modelo_nf_id
                           HAVING count(fnc.numero_nf) > 1
                             """.format(company_id=company_id.get('id')))

            dados = dictfetchall(_cr)
            if not dados:
                continue


            deletadas = []
            for i in dados:
                _cr.execute("""SELECT id
                               FROM fiscal_nf_capa 
                               WHERE numero_nf = {numero_nf}
                                 AND serie_nf = '{serie_nf}'
                                 AND company_id = {company_id}
                                 AND modelo_nf_id = {modelo_nf_id}
                               ORDER BY id  
                            """.format(numero_nf=i.get('numero_nf'),
                                       serie_nf=i.get('serie_nf'),
                                       company_id=i.get('company_id'),
                                       modelo_nf_id=i.get('modelo_nf_id'))
                            )
                nf_ids = map(lambda x: '%s' % x.get('id'), dictfetchall(_cr))[1:]
                excluida_ids.extend(nf_ids)
                deletadas.append('%s - %s' % (i.get('numero_nf'), i.get('serie_nf')))

            if deletadas:
                print '\nNotas excluídas da Empresa %s:\n%s' % (company_id.get('id'), '\n'.join(deletadas))

        _cr.execute("""DELETE FROM financeiro_tesouraria_movimento WHERE fintem_nf_id IN ({ids});
                       DELETE FROM fiscal_nf_capa WHERE id IN ({ids});
                       COMMIT;""".format(ids=','.join(excluida_ids)))
        cont += len(excluida_ids)
        print 'Finalizado, %s notas excluídas' % cont

    except Exception as e:
        print 'Erro ao atualizar notas: %s' % e

except Exception as e:
    print 'Erro ao conectar com a Base de dados:%s' % e
