# -*- coding: utf-8 -*-

# Este script recalcula a chave de acesso das notas que tiveram sua chave trocada pelo cron


import psycopg2.extras
import re


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results


class get_browse(object):
    def __init__(self, d):
        for a, b in d.items():
            if isinstance(b, (list, tuple)):
                setattr(self, a, [get_browse(x) if isinstance(x, dict) else x for x in b])
            else:
                setattr(self, a, get_browse(b) if isinstance(b, dict) else b)

def _calcula_dv(valor):
    soma = 0
    m = 2
    for i in range(len(valor) - 1, -1, -1):
        c = valor[i]
        soma += int(c) * m
        m += 1
        if m > 9:
            m = 2

    digito = 11 - (soma % 11)
    if digito > 9:
        digito = 0

    return digito

print 'Iforme os seguintes dados'
erp_host = raw_input('Ip do ERP: ')
erp_usuario = raw_input('Usuario do postgres ERP: ')
erp_nome = raw_input('Nome do Banco ERP: ')
erp_senha = raw_input('Senha do Banco ERP: ')

cont = 0
msg = []
try:
    print '>>>>>> Alterando nota......\n'
    conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host,
                            password=erp_senha, connect_timeout=20)
    cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    try:
        dict_sup = {}
        cr.execute("""SELECT nfe_chave_acesso AS chave
                      FROM fiscal_nf_capa
                      WHERE fisnfc_consumidor = True
                      GROUP BY nfe_chave_acesso
                      HAVING COUNT(nfe_chave_acesso) > 1
                    """)
        chaves = map(lambda x: x.get('chave'), dictfetchall(cr))
        notas = []
        if chaves:
            cr.execute("""SELECT fnc.id,
                                 fnc.numero_nf,
                                 fnc.serie_nf,
                                 fnc.nfe_chave_acesso,
                                 fnc.data_emissao AT TIME ZONE 'UTC' AS data_emissao,
                                 fnc.nfe_forma_emissao,
                                 ap.cpf_cnpj,
                                 fnc.company_id
                          FROM fiscal_nf_capa    AS fnc
                          INNER JOIN res_company AS rc ON rc.id = fnc.company_id
                          INNER JOIN adm_pessoa  AS ap ON ap.id = rc.rescon_pessoa_id
                          WHERE nfe_chave_acesso IN ('{chaves}')
                          ORDER BY fnc.serie_nf, fnc.numero_nf
                            """.format(chaves="', '".join(chaves)))
            dados = dictfetchall(cr)
            for i in dados:
                i = get_browse(i)
                data = '%s%02d' % (str(i.data_emissao.year)[2:], i.data_emissao.month)
                cnpj = re.sub('[^0-9]', u'', i.cpf_cnpj or u'')
                serie = int(i.serie_nf)
                numero = int(i.numero_nf)
                tipo_emissao = i.nfe_forma_emissao == '1' and i.nfe_forma_emissao or '9'
                id_ = i.id
                if tipo_emissao == '1':
                    cr.execute("""SELECT id
                                  FROM fiscal_nf_capa
                                  WHERE numero_nf = %s
                                    AND serie_nf = '%s'
                                    AND company_id = %s
                                    AND fisnfc_consumidor = True""" % (numero+1,
                                                                       i.serie_nf,
                                                                       i.company_id))
                    id_ = dictfetchall(cr)[0].get('id')

                cont += 1
                chave = '31%s%s65%03d%09d%s%08d' % (data, cnpj, serie, numero, tipo_emissao, id_)
                chave += str(_calcula_dv(chave))
                notas.append('%s --> %s' % (('%s - %s' % (i.numero_nf, i.serie_nf)).ljust(14), chave))
                cr.execute("""UPDATE fiscal_nf_capa SET nfe_chave_acesso = '%s' WHERE id = %s;
                              COMMIT;""" % (chave, i.id))

        print 'Finalizado, %s notas atualizadas' % cont
        if notas:
            print 'Notas alteradas:\n%s' % '\n'.join(notas)
        else:
            print 'Nenhuma nota encontrada com chave duplicada'

    except Exception as e:
        print 'Erro ao atualizar notas: %s' % e

except Exception as e:
    print 'Erro ao conectar com a Base de dados:%s' % e
