# -*- coding: utf-8 -*-

# Este script corrige o protocolo de cancelamento que estava com o valor 'ID' e faltando o resto dos numeros


import psycopg2.extras
import re


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results


class get_browse(object):
    def __init__(self, d):
        for a, b in d.items():
            if isinstance(b, (list, tuple)):
                setattr(self, a, [get_browse(x) if isinstance(x, dict) else x for x in b])
            else:
                setattr(self, a, get_browse(b) if isinstance(b, dict) else b)


print 'Iforme os seguintes dados'
erp_host = raw_input('Ip do ERP: ')
erp_usuario = raw_input('Usuario do postgres ERP: ')
erp_nome = raw_input('Nome do Banco ERP: ')
erp_senha = raw_input('Senha do Banco ERP: ')

cont = 0
msg = []
try:
    print '>>>>>> Alterando nota......\n'
    conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host,
                            password=erp_senha, connect_timeout=20)
    cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    try:
        dict_sup = {}
        cr.execute("""SELECT id, 
                             numero_nf,
                             serie_nf,  
                             nfe_xml_cancelamento
                      FROM fiscal_nf_capa
                      WHERE nfe_protocolo_cancelamento ilike 'ID%'
                        AND fisnfc_consumidor = True 
                    """)
        notas = []
        for i in dictfetchall(cr):
            i = get_browse(i)
            protocolo = i.nfe_xml_cancelamento.split('<nProt>')
            if len(protocolo) > 2:
                protocolo = protocolo[2].split('</nProt>')[0]
            elif len(protocolo) == 1:
                protocolo = protocolo[0].split('<infEvento Id="ID')[1][:15]
            else:
                protocolo = protocolo[1].split('</nProt>')[0]

            notas.append('%s --> %s' % (('%s - %s' % (i.numero_nf, i.serie_nf)).ljust(14), protocolo))
            cont += 1
            cr.execute("""UPDATE fiscal_nf_capa SET nfe_protocolo_cancelamento = '%s' WHERE id = %s;
                          COMMIT;""" % (protocolo, i.id))

        print 'Finalizado, %s notas atualizadas' % cont
        if notas:
            print 'Notas alteradas:\n%s' % '\n'.join(notas)
        else:
            print 'Nenhuma nota com chave incorreta encontrada'

    except Exception as e:
        print 'Erro ao atualizar notas: %s' % e

except Exception as e:
    print 'Erro ao conectar com a Base de dados:%s' % e
