# -*- coding: utf-8 -*-

# Este script Ajusta as notas que o cron tirou de pendente para cancelada


from nfe.nfc_e import nfce as nfc_e
import psycopg2.extras


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results


class get_browse(object):
    def __init__(self, d):
        for a, b in d.items():
            if isinstance(b, (list, tuple)):
                setattr(self, a, [get_browse(x) if isinstance(x, dict) else x for x in b])
            else:
                setattr(self, a, get_browse(b) if isinstance(b, dict) else b)

print 'Iforme os seguintes dados'
erp_host = raw_input('Ip do ERP: ')
erp_usuario = raw_input('Usuario do postgres ERP: ')
erp_nome = raw_input('Nome do Banco ERP: ')
erp_senha = raw_input('Senha do Banco ERP: ')

data_ini = raw_input('Data inicial(DD-MM-AAAA): ').split('-')
data_fim = raw_input('Data final(DD-MM-AAAA):').split('-')

data_ini.reverse()
data_fim.reverse()

cont = 0
try:
    print '>>>>>> Analizando notas......\n'
    conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host,
                            password=erp_senha, connect_timeout=20)
    cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    try:
        data_ini = '-'.join(data_ini)
        data_fim = '-'.join(data_fim)
        cr.execute("""SELECT fnc.id,
                             fnc.numero_nf,
                             fnc.serie_nf,
                             fnc.state,
                             mm.body
                      FROM fiscal_nf_capa    AS fnc
                      LEFT JOIN mail_message AS mm ON mm.res_id = fnc.id AND model = 'fiscal.nf.capa'
                      WHERE fnc.data_emissao >= '%s 00:00:00'
                        AND fnc.data_emissao <= '%s 23:59:59'
                        AND fnc.state IN ('C', 'I')
                            AND (body ilike '%%Pendente → Cancelada%%'
                                 OR body ilike '%%Faturada → Cancelada%%'
                                 OR body ilike '%%Faturada → Inutilizada%%')
                        AND fnc.vr_total_nf > 0
                        AND fnc.fisnfc_consumidor = True
                      ORDER BY fnc.serie_nf, fnc.numero_nf
                    """ % (data_ini, data_fim))
        for i in dictfetchall(cr):
            brw_nf = get_browse(i)
            if 'Faturada' in brw_nf.body:
                cr.execute("""UPDATE fiscal_nf_capa 
                              SET state = '3',
                                  fisnfc_nfce_contingencia_offline = True
                              WHERE id = %s;
                              COMMIT;""" % brw_nf.id)
                print "Nota %s - %s Alterada para Faturada" % (brw_nf.numero_nf, brw_nf.serie_nf)
            elif 'Pendente' in brw_nf.body:
                cr.execute("""UPDATE fiscal_nf_capa 
                              SET state = 'P',
                                  fisnfc_nfce_contingencia_offline = True
                              WHERE id = %s;
                              COMMIT;""" % brw_nf.id)
                print "Nota %s - %s Alterada para Pendente" % (brw_nf.numero_nf, brw_nf.serie_nf)

        print 'Finalizado!'

    except Exception as e:
        print 'Erro ao atualizar notas: %s' % e

except Exception as e:
    print 'Erro ao conectar com a Base de dados:%s' % e
