# -*- coding: utf-8 -*-

# Este script Ajustas as NFC-es, colocando o protocolo e o xml quando a nota nao tiver os dois campos


from nfe.nfc_e import nfce as nfc_e
from nfe.nfe_400.manual_600.cancnfe_evento import EnvEvento, RetEnvEvento, ProcEventoNFe
from nfe.nfe_400.processador import ProcessoNFe
from nfe.nfe_400.webservices import UF_CODIGO
import psycopg2.extras
from datetime import datetime
import pytz


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results


class get_browse(object):
    def __init__(self, d):
        for a, b in d.items():
            if isinstance(b, (list, tuple)):
                setattr(self, a, [get_browse(x) if isinstance(x, dict) else x for x in b])
            else:
                setattr(self, a, get_browse(b) if isinstance(b, dict) else b)


def ajustar_protocolo_autorizacao_nfce(cr, data_ini, data_fim, msg):
    cr.execute("""SELECT * 
                  FROM fiscal_parametro""")
    dados_par = dictfetchall(cr)
    for par in dados_par:
        par = get_browse(par)
        # PEGANDO DIRETO DO BANCO PARA PEGAR NOTAS DE TODAS AS EMPRESA
        cond_amb = 'AND fnc.fisnfc_nfe_status_configuracao_homologacao IS NOT NULL'
        if par.fispar_nfe_ambiente == 1:
            cond_amb = 'AND fnc.fisnfc_nfe_status_configuracao_producao IS NOT NULL'

        cr.execute("""SELECT fnc.id,
                             fnc.nfe_lote,
                             fnc.state,
                             fnc.numero_nf,
                             fnc.serie_nf,
                             fnc.nfe_chave_acesso,
                             (CASE WHEN fisnfc_nfe_status_configuracao_producao IS NOT NULL
                                   THEN 1
                                   ELSE 2
                              END) AS ambiente
                      FROM fiscal_nf_capa                AS fnc
                      INNER JOIN fiscal_modelo_nf_series AS modelo ON modelo.id = fnc.modelo_nf_series_id
                      WHERE fnc.data_emissao >= '{data_ini} 00:00:00'
                        AND fnc.data_emissao <= '{data_fim} 23:59:59'
                        AND fnc.nfe_chave_acesso IS NOT NULL
                        AND fnc.state = '3'
                        AND fnc.nfe_xml_auto IS NULL
                        AND fnc.fisnfc_consumidor = True
                        AND fnc.company_id = {company_id}
                        {cond_amb}
                   """.format(data_ini=data_ini,
                              data_fim=data_fim,
                              company_id=par.company_id,
                              cond_amb=cond_amb))
        for nf in dictfetchall(cr):
            fisnfc_ajustar_protocolo_autorizacao_nfce(cr, nf, par, msg)

    fisnfc_cronjob_ajustar_protocolo_autorizacao_cancelamento_nfce(cr, msg)
    return True

def fisnfc_cronjob_ajustar_protocolo_autorizacao_cancelamento_nfce(cr, msg):
    cr.execute("""SELECT * 
                  FROM fiscal_parametro""")
    dados_par = dictfetchall(cr)
    for par in dados_par:
        par = get_browse(par)
        # PEGANDO DIRETO DO BANCO PARA PEGAR NOTAS DE TODAS AS EMPRESA
        cond_amb = 'AND fnc.fisnfc_nfe_status_configuracao_homologacao IS NOT NULL'
        if par.fispar_nfe_ambiente == 1:
            cond_amb = 'AND fnc.fisnfc_nfe_status_configuracao_producao IS NOT NULL'

        cr.execute("""SELECT fnc.id,
                             fnc.nfe_lote,
                             fnc.state,
                             fnc.numero_nf,
                             fnc.serie_nf,
                             fnc.nfe_chave_acesso,
                             (CASE WHEN fisnfc_nfe_status_configuracao_producao IS NOT NULL
                                   THEN 1
                                   ELSE 2
                              END) AS ambiente
                      FROM fiscal_nf_capa                AS fnc
                      INNER JOIN fiscal_modelo_nf_series AS modelo ON modelo.id = fnc.modelo_nf_series_id
                      WHERE fnc.data_emissao >= '{data_ini} 00:00:00'
                        AND fnc.data_emissao <= '{data_fim} 23:59:59'
                        AND fnc.nfe_chave_acesso IS NOT NULL
                        AND fnc.state = 'C'
                        AND fnc.nfe_xml_cancelamento IS NULL
                        AND fnc.fisnfc_consumidor = True
                        AND fnc.company_id = {company_id}
                        {cond_amb}
                   """.format(data_ini=data_ini,
                              data_fim=data_fim,
                              company_id=par.company_id,
                              cond_amb=cond_amb))
        for nf in dictfetchall(cr):
            fisnfc_ajustar_protocolo_autorizacao_nfce(cr, nf, par, msg)
            
    return True

def fisnfc_ajustar_protocolo_autorizacao_nfce(cr, dados_nf, parametro, msg):
    brw_nf = get_browse(dados_nf)
    print 'Processando Nota %s - %s ...' % (brw_nf.numero_nf, brw_nf.serie_nf)
    company_id = parametro.company_id
    cr.execute("""SELECT ap.id,
                         ap.uf
                  FROM adm_pessoa       AS ap
                  LEFT JOIN res_company AS rc ON rc.rescon_pessoa_id = ap.id
                  WHERE rc.id = %s
               """ % company_id)
    brw_pessoa = get_browse(dictfetchall(cr)[0])
    try:
        nf = nfc_e(parametro.certificado_conteudo,
                   parametro.chave_conteudo,
                   brw_nf.ambiente,
                   brw_pessoa.uf,
                   False)
        nf.process.tentativas = parametro.fispar_nfce_tentativa_envio or 5
        nf.process.timeout = parametro.fispar_nfce_conexao_timeout or 10
        if brw_nf.nfe_lote and brw_nf.state == '3':
            processo = nf.process.consultar_recibo(brw_nf.nfe_lote)
            try:
                numero = int(processo.resposta.protNFe[0].infProt.chNFe.valor[25:34])
            except:
                numero = False

            if processo.resposta.cStat.valor != u'104' or numero != brw_nf.numero_nf:  # Lote nao encontrado
                processo, __ = nf.consultar_nota(brw_nf.nfe_chave_acesso)
                print 'Status SEFAZ: %s - %s' % (processo.resposta.cStat.valor,
                                                 processo.resposta.xMotivo.valor)
                if processo.resposta.cStat.valor in (u'100', u'150'):
                    cr.execute("""UPDATE fiscal_nf_capa 
                                  SET nfe_xml_auto = '%s' 
                                  WHERE id = %s;
                                  COMMIT;""" % (processo.resposta.protNFe.xml, brw_nf.id))
                    print 'Nota %s - %s "nfe_xml_auto" recuperado!' % (brw_nf.numero_nf, brw_nf.serie_nf)

            else:  # Lote processado
                cr.execute("""UPDATE fiscal_nf_capa 
                              SET nfe_xml_auto = '%s' 
                              WHERE id = %s;
                              COMMIT;""" % (processo.resposta.protNFe[0].xml, brw_nf.id))
                print 'Lote processado: %s' % brw_nf.nfe_lote
                print 'Nota %s - %s "nfe_xml_auto" recuperado!' % (brw_nf.numero_nf, brw_nf.serie_nf)

        elif brw_nf.nfe_chave_acesso:
            processo, __ = nf.process.consultar_nota(brw_nf.nfe_chave_acesso)
            print 'Status SEFAZ: %s - %s' % (processo.resposta.cStat.valor,
                                             processo.resposta.xMotivo.valor)
            if processo.resposta.cStat.valor in (u'100', u'150'):
                cr.execute("""UPDATE fiscal_nf_capa 
                              SET nfe_xml_auto = '%s', 
                                  state = '3'
                              WHERE id = %s;
                              COMMIT;""" % (processo.resposta.protNFe.xml, brw_nf.id))
                print 'Nota %s - %s "nfe_xml_auto" recuperado!' % (brw_nf.numero_nf, brw_nf.serie_nf)

            elif processo.resposta.cStat.valor == u'101':
                protocolo = processo.resposta.protNFe.infProt.nProt.valor
                xml_canc = fisnit_gerar_xml_cancelamento(cr, processo, brw_nf, parametro, protocolo)
                prot_cancelamento = processo.resposta.retCancNFe.infCanc.nProt.valor
                cr.execute("""UPDATE fiscal_nf_capa 
                              SET nfe_xml_auto = '%s',
                                  nfe_xml_cancelamento = '%s',
                                  state = 'C',
                                  nfe_status = '%s',
                                  nfe_protocolo_cancelamento = '%s'
                              WHERE id = %s;
                              COMMIT;""" % (processo.resposta.protNFe.xml,
                                            xml_canc,
                                            '%s - %s' % (processo.resposta.retCancNFe.infCanc.cStat.valor,
                                                         processo.resposta.retCancNFe.infCanc.xMotivo.valor),
                                            prot_cancelamento,
                                            brw_nf.id))
                print 'Nota %s - %s "nfe_xml_cancelamento" recuperado!' % (brw_nf.numero_nf, brw_nf.serie_nf)

            elif processo.resposta.cStat.valor in (u'137', u'217') and brw_nf.state != '3':
                cr.execute("""UPDATE fiscal_nf_capa 
                              SET state = 'I',
                                  nfe_status = '102 - Inutilizacao de numero homologado' 
                              WHERE id = %s;
                              COMMIT;""" % brw_nf.id)
                print 'Nota %s - %s alterada para "Inutilizada"!' % (brw_nf.numero_nf, brw_nf.serie_nf)
            else:
                print 'Nota não alterada'

        print '\n\n'

    except Exception as err:
        print 'CRON - Ajusta XML %s >> %s' % (brw_nf.nfe_chave_acesso, err)

def fisnit_gerar_xml_cancelamento(cr, consulta, brw_capa, parametros, protocolo):
    """Refaz o xml de cancelamento"""
    ambiente = parametros.fispar_nfe_ambiente or 2
    company_id = parametros.company_id
    cr.execute("""SELECT ap.id,
                             ap.uf
                      FROM adm_pessoa       AS ap
                      LEFT JOIN res_company AS rc ON rc.rescon_pessoa_id = ap.id
                      WHERE rc.id = %s
                   """ % company_id)
    brw_pessoa = get_browse(dictfetchall(cr)[0])
    proc_nfce = nfc_e(parametros.certificado_conteudo,
                      parametros.chave_conteudo,
                      ambiente,
                      brw_pessoa.uf)
    chave = brw_capa.nfe_chave_acesso
    envio = EnvEvento()
    resposta = RetEnvEvento()
    processo = ProcessoNFe(2, envio, resposta)
    envio.infEvento.tpAmb.valor = ambiente
    envio.infEvento.chNFe.valor = chave
    envio.infEvento.nProt.valor = protocolo
    envio.infEvento.xJust.valor = 'Nota fiscal emitida em contingencia'
    envio.infEvento.cOrgao.valor = UF_CODIGO[brw_pessoa.uf]
    dt = datetime.utcnow()
    dt = dt.replace(tzinfo=pytz.utc)
    data_hora_tz = datetime.astimezone(dt, pytz.timezone("Brazil/East"))
    data_evento = datetime.strftime(data_hora_tz, u'%Y-%m-%dT%H:%M:%S') + str(data_hora_tz)[-6:]
    envio.infEvento.dhEvento.valor = data_evento
    envio.infEvento.CNPJ.valor = chave[6:20]
    proc_nfce.process.certificado.assina_xmlnfe(envio)
    envio.validar()
    # seta os dados que nao tem
    resposta.retEvento.infEvento.cStat.valor = u'135'
    resposta.retEvento.infEvento.tpAmb.valor = ambiente
    resposta.retEvento.infEvento.verAplic.valor = consulta.resposta.protNFe.infProt.verAplic.valor
    resposta.retEvento.infEvento.cOrgao.valor = consulta.resposta.retCancNFe.infCanc.cOrgao.valor
    resposta.retEvento.infEvento.xMotivo.valor = consulta.resposta.retCancNFe.infCanc.xMotivo.valor
    resposta.retEvento.infEvento.dhRegEvento.valor = str(consulta.resposta.retCancNFe.infCanc.dhRegEvento.valor).replace(' ', 'T')
    protocolo_canc = consulta.resposta.retCancNFe.infCanc.nProt.valor
    resposta.retEvento.infEvento.nProt.valor = protocolo_canc
    resposta.retEvento.infEvento.chNFe.valor = chave
    resposta.retEvento.infEvento.Id.valor = 'ID%s' % protocolo_canc
    processo_cancelamento_nfe = ProcEventoNFe()
    processo_cancelamento_nfe.envEvento = envio
    processo_cancelamento_nfe.retEnvEvento = resposta
    processo_cancelamento_nfe.validar()
    processo.processo_cancelamento_nfe = processo_cancelamento_nfe
    return processo.processo_cancelamento_nfe.xml


print 'Iforme os seguintes dados'
erp_host = raw_input('Ip do ERP: ')
erp_usuario = raw_input('Usuario do postgres ERP: ')
erp_nome = raw_input('Nome do Banco ERP: ')
erp_senha = raw_input('Senha do Banco ERP: ')

data_ini = raw_input('Data inicial(DD-MM-AAAA): ').split('-')
data_fim = raw_input('Data final(DD-MM-AAAA):').split('-')

data_ini.reverse()
data_fim.reverse()

cont = 0
msg = []
try:
    print '>>>>>> Analizando notas......\n'
    conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host,
                            password=erp_senha, connect_timeout=20)
    cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    try:
        data_ini = '-'.join(data_ini)
        data_fim = '-'.join(data_fim)
        ajustar_protocolo_autorizacao_nfce(cr, data_ini, data_fim, msg)
        print '\n\nFinalizado!'
    except Exception as e:
        print 'Erro ao atualizar notas: %s' % e

except Exception as e:
    print 'Erro ao conectar com a Base de dados:%s' % e
