#!/usr/bin/python
# -*- encoding: utf-8 -*-
__author__ = 'Dener Rodrigues'

import psycopg2
import psycopg2.extras

"""
ESTE SCRIPT FOI DESENVOLVIDO ESPECIFICAMENTE PARA O ATENDIMENTO 70874
UTILIZAR SOMENTE NA BASE DO CLIENTE - CANTINA BOM SABOR -

OBS.: NAO ESQUECA DE INATIVAR A IMPORTACAO NO AGENDADOR DO SIGERP
"""


def _connection():
    host = 'localhost'
    user = 'openerp'
    password = ''
    db = 'NOME_DA_BASE'

    data_ini = 'DATA_INICIO'
    data_fin = 'DATA_FIM'

    res = False
    if all([host, user, db]):
        _cr = None
        try:
            # Conexao com o Banco de Dados
            conn = psycopg2.connect(database=db, user=user, password=password, host=host,
                                    connect_timeout=3)
            _cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
        except:
            print 'Sem conexao com banco de dados'

        if _cr:
            res =_atualiza_vr_imposto_supervisor(data_ini, data_fin, _cr)

    return res


def _converts_fetchall_to_dictfetchall(_cr):
    """
    fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
    para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
    conversao
    """

    # Testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # Substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results


def _atualiza_vr_imposto_supervisor(data_ini, data_fin, _cr):
    """
    Atualiza o valor do imposto onde Tributaapo = Outros (N)
    Valor Outros = gt_final - gt_inicial - cancelamentos - descontos - vr_trib_18 - vr_subst_trib
    """

    # Coletando dados do Mapa Fiscal
    sql = """
    SELECT  supcap.id               AS cupom_id,
            ecf.caixa               AS caixa,
            mrc.coo                 AS nro_cupom,
            mrc.data                AS data_movimento,
            mrc.gt_final            AS gt_final,
            mrc.gt_inicial          AS gt_inicial,
            mrc.cancelamentos       AS cancelamentos,
            mrc.descontos           AS descontos,
            mri.imposto_valor       AS vr_subst_trib,

            (SELECT imposto_valor
             FROM   ecf_mapa_resumo_itens
             WHERE  aliquota = 18
                    AND capa_id = mri.capa_id ) AS vr_trib_18

    FROM    ecf_mapa_resumo_itens mri

            INNER JOIN ecf_mapa_resumo_capa mrc
                    ON mrc.id = mri.capa_id
            INNER JOIN ecf_ecf ecf
                    ON ecf.id = mrc.ecf
            INNER JOIN supervisor_mov_capa supcap
                    ON supcap.supcap_nro_cupom = mrc.coo

    WHERE   mri.tipo IN ('F')
            AND mrc.data >= '%s'
            AND mrc.data <= '%s'

    GROUP
       BY   mri.id,
            mrc.data,
            ecf.caixa,
            supcap.id,
            mrc.coo,
            mrc.gt_final,
            mrc.gt_inicial,
            mrc.cancelamentos,
            mrc.descontos,
            mri.imposto_valor

    ORDER
       BY   mrc.data
    """ % (data_ini, data_fin)

    print sql
    _cr.execute(sql)
    dados = _converts_fetchall_to_dictfetchall(_cr)
    res = False
    total = 0
    for x in dados:
        cupom_id = x['cupom_id']
        caixa = x['caixa']
        nro_cupom = x['nro_cupom']
        gt_final = x['gt_final']
        gt_inicial = x['gt_inicial']
        cancelamentos = x['cancelamentos']
        descontos = x['descontos']
        vr_trib_18 = x['vr_trib_18']
        vr_subst_trib = x['vr_subst_trib']

        val = gt_final - gt_inicial - cancelamentos - descontos - vr_trib_18 - vr_subst_trib

        # Atualizando as Reducoes Z no Supervisor
        sql = """
        UPDATE  supervisor_mov_totalizadores_xz
        SET     suptxz_valor = %s
        WHERE   suptxz_capa_id = %s
                AND suptxz_tipo_tributacao IN ('N', 'O')
        """ % (val, cupom_id)
        print sql

        total += val

        _cr.execute(sql)
    _cr.connection.commit()
    print 'Total Imposto - Outros: ', total

    # Se obteve alguma atualizacao, reimporta todas as Reducoes Z
    if total:
        res = _reimporta_z(_cr, data_ini, data_fin)

    return res


def _reimporta_z(_cr, data_ini, data_fin):
    """
    Reimporta todas as Reducoes Z do Supervisor
    """

    res = True
    print 'Reimportando Reducoes Z'
    try:
        sql_1 = """
        UPDATE  supervisor_mov_cupom_servidor
        SET     supcse_enviado = False
        WHERE   supcse_capa_id IN (SELECT id
                                   FROM   supervisor_mov_capa
                                   WHERE  supcap_nro_cupom IN (SELECT coo
                                                               FROM   ecf_cupons_capa
                                                               WHERE  tipo_cupom = 'Z'
                                                                      AND date_cupom >= '%s'
                                                                      AND date_cupom <= '%s'))
        """ % (data_ini, data_fin)
        print sql_1
        _cr.execute(sql_1)

        sql_2 = """
        DELETE FROM ecf_mapa_resumo_capa
        WHERE       coo IN (SELECT coo
                            FROM   ecf_cupons_capa
                            WHERE  tipo_cupom = 'Z'
                                   AND date_cupom >= '%s'
                                   AND date_cupom <= '%s')
        """ % (data_ini, data_fin)
        print sql_2
        _cr.execute(sql_2)

        sql_3 = """
        DELETE FROM ecf_cupons_capa
        WHERE       tipo_cupom = 'Z'
                    AND date_cupom >= '%s'
                    AND date_cupom <= '%s'
        """ % (data_ini, data_fin)
        print sql_3
        _cr.execute(sql_3)

    except Exception as e:
        print e, '\n\nNao foi possivel reimportar Reducoes Z, verifique o erro acima!'
        res = False

    if res is True:
        _cr.connection.commit()
        print 'Fim de Execucao! \nA IMPORTACAO NO AGENDADOR DO SIGERP JA PODE SER ATIVADA!'

    return res


if __name__ == "__main__":
    _connection()
