SELECT *
FROM   (SELECT ep.codigo
               AS
                      codigo_produto,
               ep.NAME
               AS
                      descricao,
               fte.tipo_tributacao,
               Cast('PIS' AS TEXT)
               AS pis
                      ,
               (SELECT codigo
                FROM   fiscal_cst
                WHERE  id = (SELECT cst_id
                             FROM   fiscal_tributacao_encargos
                             WHERE  produto_id = fte.produto_id
                                    AND tipo_tributacao = fte.tipo_tributacao
                                    AND encargo_id = (SELECT id
                                                      FROM   fiscal_encargo
                                                      WHERE  sigla = 'PIS')))
               AS
                      cst_pis,
               Cast('COFINS' AS TEXT)
               AS
                      cofins,
               (SELECT codigo
                FROM   fiscal_cst
                WHERE  id = (SELECT cst_id
                             FROM   fiscal_tributacao_encargos
                             WHERE  produto_id = fte.produto_id
                                    AND tipo_tributacao = fte.tipo_tributacao
                                    AND encargo_id = (SELECT id
                                                      FROM   fiscal_encargo
                                                      WHERE  sigla = 'COFINS')))
               AS
                      cst_cofins
        FROM   fiscal_tributacao_encargos fte
               INNER JOIN estoque_produto ep
                       ON ep.id = fte.produto_id
               INNER JOIN fiscal_encargo fe
                       ON fe.id = fte.encargo_id
        WHERE  fe.sigla IN ( 'PIS', 'COFINS' )) AS tmp
WHERE  cst_pis <> cst_cofins
GROUP  BY codigo_produto,
          descricao,
          cst_pis,
          cst_cofins,
          tipo_tributacao,
          pis,
          cofins
