#!/usr/bin/python
# -*- encoding: utf-8 -*-
import psycopg2
import getpass
import xmlrpclib, socket


class DeletaProduto():
    def __init__(self):
        self.database = str(raw_input('Nome do banco: '))
        self.host = str(raw_input('IP do banco: '))
        self.user = str(raw_input('Usuario do banco: '))
        self.user1 = str(raw_input('Usuario do Odoo (OpenERP): '))
        self.password = getpass.getpass('Senha do banco: ')
        self.password1 = getpass.getpass('Senha do Odoo (OpenERP): ')
        self.port = raw_input('Porta do banco: ')
        self.port1 = raw_input('Porta do Odoo (OpenERP): ')
        self.conn, self.sock = self.new_connection()
        self.cr = self.conn.cursor()
        self.cr1 = self.sock
        produto_ids = self.get_produto()
        self.deleta_produto(produto_ids)
        self.uid = False

    def new_connection(self):
        if not self.password:
            self.password = None
        if not self.port:
            self.port = 5432
        try:
            conn = psycopg2.connect(database=self.database, user=self.user, password=self.password,
                                    host=self.host, port=self.port, connect_timeout=3)
        except Exception as err:
            print 'Nao foi possivel conectar ao banco de dados!'
            print str(err)
            exec exit()

        try:
            sock_common = xmlrpclib.ServerProxy('http://'+self.host+':'+str(
                self.port1)+'/xmlrpc/common')
            socket.setdefaulttimeout(3)
            self.uid = sock_common.login(self.database, self.user1, self.password1)
            sock = xmlrpclib.ServerProxy('http://' + self.host + ':' + str(self.port1) +
                                         '/xmlrpc/object')
            company_ids = sock.execute(self.database, self.uid, self.password1, 'res.company',
                                       'search', [])
        except Exception as err:
            print 'Nao foi possivel conectar ao Odoo(OpenERP)!'
            print str(err)
            exec exit()
        return conn, sock

    def converts_fetchall_to_dictfetchall(self, _cr):
        """
        fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
        para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
        conversao
        """

        # Testa resultados armazenados
        results = _cr.fetchall()
        if results < 1:
            return results

        # Substitui resultados das listas por dicionarios
        rownum = 0
        for row in results:
            dictrow = {}
            dictnum = 0
            for col in _cr.description:
                dictrow[col[0]] = row[dictnum]
                dictnum += 1

            results[rownum] = dictrow
            rownum += 1

        return results

    def get_produto(self):
        sql = """
            SELECT id
            FROM estoque_produto
            WHERE
                id NOT IN (
                    SELECT distinct produto_id FROM estoque_preco_venda
                    UNION
                    SELECT distinct produto_id FROM estoque_preco_custo)
        """
        self.cr.execute(sql)
        res = self.converts_fetchall_to_dictfetchall(self.cr)
        res = list(set(map(lambda i: i.get('id'), res)))
        return res

    def deleta_produto(self, produto_ids):
        count = 0
        for produto_id in produto_ids:
            try:
                self.cr1.execute(self.database, self.uid, self.password1,
                                 'estoque.produto', 'unlink',
                                 [produto_id], {})
                print 'EXCLUINDO PRODUTO_ID: %s' % produto_id
                count += 1
            except:
                pass
        print 'FINALIZOU A EXCLUSÃO DOS PRODUTOS. %s FORAM EXCLUÍDOS' % count
        return True

deleta_produto = DeletaProduto()
