#!/usr/bin/python
# -*- encoding: utf-8 -
"""
Acerta o valor da base de calculo de pis cofins de itens vendidos em cupons
Base sera vr_total_item - desconto + acrescimo
"""


# !/usr/bin/python
# -*- encoding: utf-8 -*-
from openerp.osv import fields
import psycopg2
from getpass import getpass


def dictfetchall(cr):
    """Retorna todas as linhas de um cursor como um dicionario"""
    desc = cr.description
    return [dict(zip([col[0] for col in desc], row)) for row in cr.fetchall()]


def get_valores(cr, dt_ini, dt_fim):
    sql = """
            SELECT     emi.id,
                       fisnit.id AS fisnit_id,
                       emi.cupom_id,
                       emi.NAME,
                       emi.vr_total_item_rateado,
                       vr_total_item,
                       emi.vr_desconto,
                       emi.vr_acrescimos,
                       fisnit.vr_base_calculo,
                       fisnit.aliquota
            FROM       estoque_movimento_itens emi
            INNER JOIN fiscal_nf_item_tributacao fisnit
            ON         emi.id = fisnit.movimento_itens_id
            INNER JOIN fiscal_encargo fisenc
            ON         fisenc.id = fisnit.encargo_id
            INNER JOIN  ecf_cupons_capa ecc
            ON         ecc.id = emi.cupom_id
            WHERE      fisenc.sigla IN ('PIS', 'COFINS')
            AND        emi.vr_total_item_rateado <> fisnit.vr_base_calculo
            AND ecc.date_cupom BETWEEN '{dt_ini}' AND '{dt_fim}'
                        """.format(dt_ini=dt_ini, dt_fim=dt_fim)
    cr.execute(sql)
    return dictfetchall(cr)


def set_valores(cr, fisnit_id, vr_base, vr_encargo):
    sql = "UPDATE fiscal_nf_item_tributacao set vr_base_calculo = {vr_base}, vr_encargo = {vr_encargo} " \
          "WHERE id = {fisnit_id}" \
        .format(vr_base=vr_base, fisnit_id=fisnit_id, vr_encargo=vr_encargo)
    try:
        cr.execute(sql)
        cr.connection.commit()
    except Exception as e:
        cr.connection.rollback()
        print e.message


if __name__ == '__main__':

    host = raw_input('IP do banco: ')
    db = raw_input('Nome do banco: ')
    user = raw_input('Usuario do banco: ')
    password = getpass('Senha do banco: ')
    port = raw_input('Porta do banco: ')
    dt_ini = raw_input('Data inicio: ')
    dt_fim = raw_input('Data final: ')
    try:
        con = psycopg2.connect(database=db, user=user, password=password, port=port, host=host,
                               connect_timeout=3)
        cr = con.cursor()
        dados = get_valores(cr, dt_ini, dt_fim)
        for dado in dados:
            fisnit_id = dado.get('fisnit_id')
            vr_base_calculo = dado.get('vr_base_calculo')
            aliquota = dado.get('aliquota')
            vr_base_calculo = dado.get('vr_total_item') - dado.get('vr_desconto') or 0.00 + dado. \
                get('vr_acrescimo') or 0.00
            vr_encargo = (vr_base_calculo * aliquota) / 100
            vr_encargo = float(fields.float_round(vr_encargo, 2))
            print 'ID:{fisnit_id}\t\tVALOR CALCULADO: Base - {vr_base_calculo} \t' \
                  'Encargo - {vr_encargo}'.format(fisnit_id=fisnit_id,
                                                  vr_base_calculo=vr_base_calculo,
                                                  vr_encargo=vr_encargo)
            set_valores(cr, fisnit_id, vr_base_calculo, vr_encargo)
    except:
        raise
