#!/usr/bin/python
# -*- encoding: utf-8 -*-
import xmlrpclib, socket
import getpass


class AcertaBase():
    def __init__(self):
        self.database = str(raw_input('Nome do banco: '))
        self.host = str(raw_input('IP do banco: '))
        self.user = str(raw_input('Usuario do OpenERP(ODOO): '))
        self.password = getpass.getpass('Senha do OpenERP(ODOO): ')
        self.port = raw_input('Porta do OpenERP(ODOO): ')
        self.conn, self.uid = self.new_connection()
        movimento_ids = self.get_movimento_ids_sem_rateio()
        nf_dict = self.get_nf_sem_rateio(movimento_ids)
        self.set_movimento_sem_rateio(nf_dict)
        print 'MOVIMENTO DE ITENS CORRIGIDO PARA OS VALORES DE RATEIO'

    def new_connection(self):
        if not self.password:
            self.password = None
        if not self.port:
            self.port = 8069
        try:
            sock_common = xmlrpclib.ServerProxy('http://' + self.host + ':' + str(self.port) +
                                                '/xmlrpc/common')
            socket.setdefaulttimeout(3)
            uid = sock_common.login(self.database, self.user, self.password)
            sock = xmlrpclib.ServerProxy('http://' + self.host + ':' + str(self.port) +
                                         '/xmlrpc/object')
            return sock, uid
        except:
            print 'Nao foi possivel conectar ao OpenERP (ODOO)!'
            exec exit()

    def get_movimento_ids_sem_rateio(self):
        movimento_ids = self.conn.execute(self.database, self.uid, self.password,
                                          'estoque.movimento.itens', 'search',
                                          [('nf_id', '!=', False),
                                           ('vr_total_item_rateado', '=', False)])
        return movimento_ids

    def get_nf_sem_rateio(self, movimento_ids):
        nf_dict = {}
        if not movimento_ids:
            return nf_dict
        estoque_movimento_itens_dados = self.conn.execute(self.database, self.uid, self.password,
                                                          'estoque.movimento.itens', 'read',
                                                          movimento_ids, ['nf_id'], {},
                                                          '_classic_write')
        nf_ids = list(set(map(lambda i: i.get('nf_id'), estoque_movimento_itens_dados)))
        for nf_id in nf_ids:
            movimento_itens_nf_id = filter(lambda i: i.get('nf_id') == nf_id,
                                           estoque_movimento_itens_dados)
            nf_dict[nf_id] = map(lambda i: i.get('id'), movimento_itens_nf_id)
        return nf_dict

    def set_movimento_sem_rateio(self, nf_dict):
        nf_ids = nf_dict.keys()
        list_fields = ['vr_desconto', 'vr_frete', 'vr_seguro', 'vr_despesas_acessorias',
                       'fisnfc_vr_despesas_extras', 'vr_icms_frete', 'tipo_frete']
        fiscal_nf_capa_dados = self.conn.execute(self.database, self.uid, self.password,
                                                 'fiscal.nf.capa', 'read', nf_ids, list_fields)
        for nf in fiscal_nf_capa_dados:
            nf_id = nf.get('id')
            itens_gravados = nf_dict.get(nf_id)
            vr_desconto = nf.get('vr_desconto') or 0
            vr_frete = nf.get('vr_frete') or 0
            vr_seguro = nf.get('vr_seguro') or 0
            vr_despesas_acessorias = nf.get('vr_despesas_acessorias') or 0
            vr_despesas_extras = nf.get('fisnfc_vr_despesas_extras') or 0
            vr_icms_frete = nf.get('vr_icms_frete') or 0
            tipo_frete = nf.get('tipo_frete')
            movimento_item_ids = self.conn.execute(
                self.database, self.uid, self.password, 'fiscal.nf.capa', 'calcula_rateio',
                vr_desconto, vr_frete, vr_seguro, vr_despesas_acessorias, vr_despesas_extras,
                vr_icms_frete, itens_gravados, [], tipo_frete, {})
            self.conn.execute(self.database, self.uid, self.password, 'fiscal.nf.capa', 'write',
                              [nf_id], {'estoque_movimento_itens_ids': movimento_item_ids},
                              {'super_write_fiscal_nf_capa': True,
                               'super_write_estoque_movimento_itens': True})
        return True

acertabase = AcertaBase()
