# verificar lancamentos da tesouraria sem custificacao
select ftm.id, ftm.debito_credito, ftm.valor, ftm.historico, ftm.titulo_id, ftm.data_movimento, gm.centro_custo_id, gm.evento_id
   from financeiro_tesouraria_movimento ftm
   left join gerencial_movimento gm on gm.tesouraria_movimento_id=ftm.id
   where ftm.conta_destino_id isnull and gm.centro_custo_id isnull
   order by data_movimento desc


select ano_competencia, mes_competencia, data_prorrogacao, extract(year from data_prorrogacao), tipo_titulo,
	cast(extract(year from data_prorrogacao) as varchar),
	cast(extract(month from data_prorrogacao) as varchar)
from gerencial_movimento gm
   left join financeiro_titulo ft on ft.id = gm.titulo_id
   where titulo_id > 0 and
         cast(extract(year from data_prorrogacao) as varchar) <> ano_competencia

begin transaction;
update gerencial_movimento gm
    set ano_competencia=cast(extract(year from data_prorrogacao) as varchar)
    from financeiro_titulo ft
    where ft.id = gm.titulo_id and gm.id in (select gm.id from gerencial_movimento gm
   left join financeiro_titulo ft on ft.id = gm.titulo_id
   where titulo_id > 0 and
         cast(extract(year from data_prorrogacao) as varchar) <> ano_competencia);
commit;


select ano_competencia, mes_competencia, data_prorrogacao, extract(year from data_prorrogacao), tipo_titulo,
	cast(extract(year from data_prorrogacao) as varchar),
	cast(extract(month from data_prorrogacao) as varchar)
from gerencial_movimento gm
   left join financeiro_titulo ft on ft.id = gm.titulo_id
   where titulo_id > 0 and
         cast(extract(month from data_prorrogacao) as varchar) <> mes_competencia


begin transaction;
update gerencial_movimento gm
    set mes_competencia=cast(extract(month from data_prorrogacao) as varchar)
    from financeiro_titulo ft
    where ft.id = gm.titulo_id and gm.id in (select gm.id from gerencial_movimento gm
   left join financeiro_titulo ft on ft.id = gm.titulo_id
   where titulo_id > 0 and
         cast(extract(month from data_prorrogacao) as varchar) <> mes_competencia);
commit;

begin transaction;
update gerencial_movimento set mes_competencia = '01' where mes_competencia='1';
update gerencial_movimento set mes_competencia = '02' where mes_competencia='2';
update gerencial_movimento set mes_competencia = '03' where mes_competencia='3';
update gerencial_movimento set mes_competencia = '04' where mes_competencia='4';
update gerencial_movimento set mes_competencia = '05' where mes_competencia='5';
update gerencial_movimento set mes_competencia = '06' where mes_competencia='6';
update gerencial_movimento set mes_competencia = '07' where mes_competencia='7';
update gerencial_movimento set mes_competencia = '08' where mes_competencia='8';
update gerencial_movimento set mes_competencia = '09' where mes_competencia='9';
commit;

begin transaction;
update gerencial_movimento gm
   set fingmo_operacao = 'S'
   from financeiro_tesouraria_movimento ftm
   where ftm.id = gm.tesouraria_movimento_id and
         fingmo_operacao isnull and
         tesouraria_movimento_id >  0 and
         debito_credito = 'D';
update gerencial_movimento gm
   set fingmo_operacao = 'E'
   from financeiro_tesouraria_movimento ftm
   where ftm.id = gm.tesouraria_movimento_id and
         fingmo_operacao isnull and
         tesouraria_movimento_id >  0 and
         debito_credito = 'C'
commit
