#!/usr/bin/python
# -*- encoding: utf-8 -*-
import psycopg2
import getpass


class AcertaBase():
    def __init__(self):
        self.database = str(raw_input('Nome do banco: '))
        self.host = str(raw_input('IP do banco: '))
        self.user = str(raw_input('Usuario do banco: '))
        self.password = getpass.getpass('Senha do banco: ')
        self.port = raw_input('Porta do banco: ')
        self.conn = self.new_connection()
        self.cr = self.conn.cursor()
        dados = self.get_fatura_replicada()
        self.acerta_fatura_replicada(dados)

    def new_connection(self):
        if not self.password:
            self.password = None
        if not self.port:
            self.port = 5432
        try:
            conn = psycopg2.connect(database=self.database, user=self.user, password=self.password,
                                    host=self.host, port=self.port, connect_timeout=3)
            return conn
        except:
            print 'Nao foi possivel conectar ao banco de dados!'
            exec exit()

    def converts_fetchall_to_dictfetchall(self, _cr):
        """
        fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
        para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
        conversao
        """

        # Testa resultados armazenados
        results = _cr.fetchall()
        if results < 1:
            return results

        # Substitui resultados das listas por dicionarios
        rownum = 0
        for row in results:
            dictrow = {}
            dictnum = 0
            for col in _cr.description:
                dictrow[col[0]] = row[dictnum]
                dictnum += 1

            results[rownum] = dictrow
            rownum += 1

        return results

    def get_fatura_replicada(self):
        sql = """
            SELECT
                count(cupom_id) as qtd,
                cupom_id
            FROM
                financeiro_fatura
            WHERE
                cupom_id IS NOT NULL
            GROUP BY cupom_id
        """
        self.cr.execute(sql)
        res = self.converts_fetchall_to_dictfetchall(self.cr)
        return res

    def acerta_fatura_replicada(self, dados):
        dados = filter(lambda i: i.get('qtd') > 1, dados)
        cupom_ids = map(lambda i: i.get('cupom_id'), dados)
        for cupom_id in cupom_ids:
            sql = """
                SELECT id FROM financeiro_fatura WHERE cupom_id = %s
            """ % cupom_id
            self.cr.execute(sql)
            fatura_dados = self.converts_fetchall_to_dictfetchall(self.cr)
            fatura_ids = map(lambda i: i.get('id'), fatura_dados)
            fatura_ids = fatura_ids[1:]
            if len(fatura_ids) == 1:
                fatura_ids = str(tuple(fatura_ids)).replace(',', '')
            elif len(fatura_ids) > 1:
                fatura_ids = str(tuple(fatura_ids))
            if fatura_ids:
                sql = """
                    DELETE FROM financeiro_titulo_baixa
                    WHERE tesouraria_movimento_id IN (
                        SELECT id
                        FROM financeiro_tesouraria_movimento
                        WHERE titulo_id IN (SELECT id FROM financeiro_titulo WHERE fatura_id IN %s))
                """ % fatura_ids
                self.cr.execute(sql)
                sql = """
                    DELETE FROM financeiro_tesouraria_movimento
                    WHERE titulo_id IN (SELECT id FROM financeiro_titulo WHERE fatura_id IN %s)
                """ % fatura_ids
                self.cr.execute(sql)
                sql = """
                    DELETE FROM financeiro_fatura WHERE id in %s
                """ % fatura_ids
                self.cr.execute(sql)
                self.conn.commit()
        print 'FINALIZOU O ACERTO DAS FATURAS'
        return True

acertabase = AcertaBase()
