#!/usr/bin/python
# -*- encoding: utf-8 -*-
from openerp.osv import fields
import psycopg2
from getpass import getpass


def dictfetchall(cr):
    """Retorna todas as linhas de um cursor como um dicionario"""
    desc = cr.description
    return [dict(zip([col[0] for col in desc], row)) for row in cr.fetchall()]


def get_encargos(cr, encargo, dt_ini, dt_fim):
    sql = """
            SELECT     fisnit.id,
                       fisnit.aliquota,
                       fisnit.vr_base_calculo
            FROM       fiscal_nf_item_tributacao fisnit
            INNER JOIN estoque_movimento_itens emi
            ON         emi.id = fisnit.movimento_itens_id
            LEFT JOIN  fiscal_nf_capa fisnfc
            ON         fisnfc.id = emi.nf_id
            LEFT JOIN  ecf_cupons_capa ecc
            ON         ecc.id = emi.cupom_id
            WHERE      fisnit.encargo_id IN
                       (
                              SELECT id
                              FROM   fiscal_encargo
                              WHERE  sigla = '{encargo}')
            AND
                       CASE
                                  WHEN emi.cupom_id IS NOT NULL
                                  THEN ecc.date_cupom BETWEEN '{dt_ini}' AND        '{dt_fim}'
                                  ELSE
                                             CASE
                                                        WHEN fisnfc.tipo = 'E'
                                                        THEN fisnfc.data_saida_entrada
                                                          BETWEEN '{dt_ini}' AND        '{dt_fim}'
                                                        ELSE fisnfc.data_emissao
                                                          BETWEEN '{dt_ini}' AND        '{dt_fim}'
                                             END
                       END
            """.format(encargo=encargo, dt_ini=dt_ini, dt_fim=dt_fim)
    cr.execute(sql)
    return dictfetchall(cr)


def set_encargo(cr, fisnit_id, vr_encargo):
    sql = "UPDATE fiscal_nf_item_tributacao set vr_encargo = {vr_encargo} WHERE id = {fisnit_id}"\
        .format(vr_encargo=vr_encargo, fisnit_id=fisnit_id)
    try:
        cr.execute(sql)
        cr.connection.commit()
    except Exception as e:
        cr.connection.rollback()
        print e.message

if __name__ == '__main__':

    host = raw_input('IP do banco: ')
    db = raw_input('Nome do banco: ')
    user = raw_input('Usuario do banco: ')
    password = getpass('Senha do banco: ')
    port = raw_input('Porta do banco: ')
    dt_ini = raw_input('Data inicio: ')
    dt_fim = raw_input('Data final: ')
    encargo = raw_input('Encargo: ').upper()
    try:
        con = psycopg2.connect(database=db, user=user, password=password, port=port, host=host,
                               connect_timeout=3)
        cr = con.cursor()
        dados = get_encargos(cr, encargo, dt_ini, dt_fim)
        for dado in dados:
            fisnit_id = dado.get('id')
            vr_base_calculo = dado.get('vr_base_calculo')
            aliquota = dado.get('aliquota')
            vr_encargo = (vr_base_calculo * aliquota) / 100
            vr_encargo = float(fields.float_round(vr_encargo, 2))
            print 'ID:{fisnit_id}\t\tVALOR ENCARGO CALCULADO: {vr_encargo}'.format(
                fisnit_id=fisnit_id, vr_encargo=vr_encargo)
            set_encargo(cr, fisnit_id, vr_encargo)
    except:
        raise
