#!/usr/bin/python
# -*- encoding: utf-8 -*-
import psycopg2
import getpass


class AcertaVrEncargo():
    def __init__(self):
        self.database = str(raw_input('Nome do banco: '))
        self.host = str(raw_input('IP do banco: '))
        self.user = str(raw_input('Usuario do banco: '))
        self.password = getpass.getpass('Senha do banco: ')
        self.port = raw_input('Porta do banco: ')
        self.conn = self.new_connection()
        self.cr = self.conn.cursor()
        self.data_inicio = raw_input('Data inicial: ')
        self.data_final = raw_input('Data final: ')
        self.company_id = raw_input('company_id: ')

    def new_connection(self):
        if not self.password:
            self.password = None
        if not self.port:
            self.port = 5432
        try:
            conn = psycopg2.connect(database=self.database, user=self.user, password=self.password,
                                    host=self.host, port=self.port)
            return conn
        except:
            print 'Nao foi possivel conectar ao banco de dados!'
            exec exit()

    @staticmethod
    def dictfetchall(cr):
        """Retorna todas as linhas de um cursor como um dicionario"""
        desc = cr.description
        return [dict(zip([col[0] for col in desc], row)) for row in cr.fetchall()]

    def get_diferenca_encargo(self):
        sql = """
                SELECT data                                                    AS data,
                       ecf_id                                                  AS ecf_id,
                       tipo_trib                                               AS tipo_trib,
                       aliquota                                                AS aliquota,
                       Sum(vr_encargo_nf_trib)                                 AS
                       vr_encargo_nf_trib,
                       Sum(vr_mapa_itens_vr_encargo)                           AS
                       vr_mapa_itens_vr_encargo,
                       Sum(vr_encargo_nf_trib) - Sum(vr_mapa_itens_vr_encargo) AS diferenca
                FROM   (SELECT data,
                               ecf_id,
                               tipo_trib,
                               aliquota,
                               Sum(vr_encargo_nf_trib)       AS vr_encargo_nf_trib,
                               Sum(vr_mapa_itens_vr_encargo) vr_mapa_itens_vr_encargo
                        FROM   (SELECT data,
                                       ecf_id,
                                       tipo_trib,
                                       aliquota,
                                       Sum(vr_contab) AS vr_encargo_nf_trib,
                                       0.00           AS vr_mapa_itens_vr_encargo
                                FROM   (-- VENDAS DE CUPOM
                                       SELECT codigo,
                                              data,
                                              ecf_id,
                                              tipo_trib,
                                              aliquota,
                                              Sum(vr_contab) AS vr_contab,
                                              Sum(vr_base)   AS vr_base,
                                              Sum(impcred)   AS ImpCred,
                                              Sum(impisen)   AS ImpIsen,
                                              Sum(impout)    AS impOut
                                        FROM   (SELECT cf.codigo             AS codigo,
                                                       cupom.date_cupom      AS data,
                                                       cupom.ecf_id          AS ecf_id,
                                                       CASE
                                                         WHEN it_cst.tipo = 'U' THEN 'F'
                                                         ELSE it_cst.tipo
                                                       END                   AS tipo_trib,
                                                       aliquota,
                                                       Sum(it_tr.vr_encargo) AS vr_contab,
                                                       Sum(CASE
                                                             WHEN it_cst.tipo = 'T' THEN
                                                             it_tr.vr_base_calculo
                                                             ELSE 0
                                                           END)              AS vr_base,
                                                       Sum(CASE
                                                             WHEN it_cst.tipo = 'T' THEN
                                                             it_tr.vr_encargo
                                                             ELSE 0
                                                           END)              AS ImpCred,
                                                       Sum(CASE
                                                             WHEN it_cst.tipo IN ( 'I', 'U' )
                                                           THEN
                                                             it_tr.vr_base_calculo
                                                             ELSE 0
                                                           END)              AS ImpIsen,
                                                       Sum(CASE
                                                             WHEN it_cst.tipo = 'O' THEN
                                                             it_tr.vr_base_calculo
                                                             ELSE 0
                                                           END)              AS ImpOut
                                                FROM   ecf_cupons_capa cupom,
                                                       estoque_movimento_itens it,
                                                       fiscal_nf_item_tributacao it_tr,
                                                       fiscal_cst it_cst,
                                                       fiscal_encargo enc,
                                                       fiscal_cfop cf
                                                WHERE  it.cupom_id = cupom.id
                                                       AND cupom.company_id = {company_id}
                                                       AND it.id = it_tr.movimento_itens_id
                                                       AND it_tr.cst_id = it_cst.id
                                                       AND it_cst.encargo_id = enc.id
                                                       AND enc.sigla = 'ICMS'
                                                       AND it.cfop_id = cf.id
                                                       AND cupom.date_cupom >= '%s'
                                                       AND cupom.date_cupom <= '%s'
                                                       AND cupom.state = 'V'
                                                       AND cupom.tipo_cupom = 'V'
                                                       AND it.item_cancelado = false
                                                       AND it.nf_id IS NULL
                                                GROUP  BY cf.codigo,
                                                          cupom.date_cupom,
                                                          it_cst.tipo,
                                                          aliquota,
                                                          ecf_id
                                                -- CANCELAMENTO
                                                UNION ALL
                                                SELECT cf.codigo,
                                                       cupom.date_cupom       AS data,
                                                       cupom.ecf_id           AS ecf_id,
                                                       CASE
                                                         WHEN it_cst.tipo = 'U' THEN 'F'
                                                         ELSE it_cst.tipo
                                                       END                    AS tipo_trib,
                                                       aliquota,
                                                       Sum(-it_tr.vr_encargo) vr_contab,
                                                       Sum(CASE
                                                             WHEN it_cst.tipo = 'T' THEN
                                                             -it_tr.vr_base_calculo
                                                             ELSE 0
                                                           END)               AS vr_base,
                                                       Sum(CASE
                                                             WHEN it_cst.tipo = 'T' THEN
                                                             -it_tr.vr_encargo
                                                             ELSE 0
                                                           END)               AS ImpCred,
                                                       Sum(CASE
                                                             WHEN it_cst.tipo IN ( 'I', 'U' )
                                                           THEN
                                                             -it_tr.vr_base_calculo
                                                             ELSE 0
                                                           END)               AS ImpIsen,
                                                       Sum(CASE
                                                             WHEN it_cst.tipo = 'O' THEN
                                                             -it_tr.vr_base_calculo
                                                             ELSE 0
                                                           END)               AS ImpOut
                                                FROM   ecf_cupons_capa cupom,
                                                       estoque_movimento_itens it,
                                                       fiscal_nf_item_tributacao it_tr,
                                                       fiscal_cst it_cst,
                                                       fiscal_encargo enc,
                                                       fiscal_cfop cf
                                                WHERE  it.cupom_id = cupom.id
                                                       AND cupom.company_id = {company_id}
                                                       AND it.id = it_tr.movimento_itens_id
                                                       AND it_tr.cst_id = it_cst.id
                                                       AND it_cst.encargo_id = enc.id
                                                       AND enc.sigla = 'ICMS'
                                                       AND it.cfop_id = cf.id
                                                       AND cupom.date_cupom >= '%s'
                                                       AND cupom.date_cupom <= '%s'
                                                       AND cupom.state = 'V'
                                                       AND cupom.tipo_cupom = 'C'
                                                       AND it.item_cancelado = true
                                                       AND it.nf_id IS NULL
                                                GROUP  BY cf.codigo,
                                                          cupom.date_cupom,
                                                          it_cst.tipo,
                                                          aliquota,
                                                          ecf_id
                                                ORDER  BY codigo) AS tmp
                                        GROUP  BY codigo,
                                                  data,
                                                  tipo_trib,
                                                  aliquota,
                                                  ecf_id) AS tmp
                                GROUP  BY data,
                                          tipo_trib,
                                          aliquota,
                                          ecf_id
                                UNION ALL
                                SELECT mapa_capa.data                AS data,
                                       mapa_capa.ecf                 AS ecf_id,
                                       mapa_itens.tipo               AS tipo_trib,
                                       aliquota,
                                       0.00                          AS vr_encargo_nf_trib,
                                       Sum(mapa_itens.imposto_valor) AS vr_mapa_itens_vr_encargo
                                FROM   ecf_mapa_resumo_capa mapa_capa
                                       INNER JOIN ecf_mapa_resumo_itens mapa_itens
                                               ON mapa_itens.capa_id = mapa_capa.id
                                WHERE  data BETWEEN '%s' AND '%s'
                                GROUP  BY data,
                                          tipo_trib,
                                          aliquota,
                                          ecf_id) AS tmp1
                        GROUP  BY data,
                                  tipo_trib,
                                  aliquota,
                                  ecf_id) AS tmp2
                WHERE  vr_mapa_itens_vr_encargo <> vr_encargo_nf_trib
                GROUP  BY data,
                          tipo_trib,
                          aliquota,
                          ecf_id
                ORDER  BY data
        """ % (self.data_inicio, self.data_final, self.data_inicio, self.data_final,
               self.data_inicio, self.data_final)
        self.cr.execute(sql.format(company_id=self.company_id))
        dados = self.dictfetchall(self.cr)
        return dados

    def get_movimento_encargo_compativel(self, data, tipo_trib, aliquota, ecf_id ):
        sql = """
                SELECT emi.id                    AS mov_item_id,
                       item_trib.id              AS item_trib_id,
                       item_trib.vr_base_calculo AS vr_base_calculo,
                       item_trib.vr_encargo      AS vr_encargo
                FROM   estoque_movimento_itens emi
                       INNER JOIN fiscal_nf_item_tributacao item_trib
                               ON item_trib.movimento_itens_id = emi.id
                       INNER JOIN fiscal_encargo fe
                               ON fe.id = item_trib.encargo_id
                       INNER JOIN fiscal_cst fc
                               ON fc.id = item_trib.cst_id
                       INNER JOIN ecf_cupons_capa ecc
                               ON ecc.id = emi.cupom_id
                WHERE  ecc.date_cupom = '%s'
                       AND ecc.company_id = {company_id}
                       AND fe.sigla = 'ICMS'
                       AND fc.tipo = '%s'
                       AND item_trib.aliquota = %s
                       AND ecc.ecf_id = %s
                       AND ecc.tipo_cupom = 'V'
                       AND ecc.state = 'V'
                       AND emi.item_cancelado = false
                       AND item_trib.vr_encargo > 0.01
                       AND emi.nf_id IS NULL
                ORDER BY item_trib.vr_encargo DESC
                LIMIT  1
        """ % (data, tipo_trib, aliquota, ecf_id)
        self.cr.execute(sql.format(company_id=self.company_id))
        dados = self.dictfetchall(self.cr)
        return dados

    def set_acerta_encargo(self, vr_encargo, mov_trib_id):
        sql = """
                UPDATE fiscal_nf_item_tributacao
                SET    vr_encargo = %s
                WHERE  id = %s
        """ % (vr_encargo, mov_trib_id)
        try:
            self.cr.execute(sql)
            self.conn.commit()
            return True
        except:
            self.conn.rollback()
            return False


if __name__ == '__main__':
    acerta = AcertaVrEncargo()
    movimento_encargo_diferenca = acerta.get_diferenca_encargo()
    for movimento_encargo in movimento_encargo_diferenca:
        ecf_id = movimento_encargo['ecf_id']
        tipo_trib = movimento_encargo['tipo_trib']
        if tipo_trib == 'F':
            tipo_trib = 'U'
        diferenca = float(movimento_encargo['diferenca'])
        aliquota = movimento_encargo['aliquota']
        data = movimento_encargo['data']
        movimento_encargo_compativel = acerta.get_movimento_encargo_compativel(data, tipo_trib,
                                                                               aliquota, ecf_id)
        if movimento_encargo_compativel:
            trib_id = movimento_encargo_compativel[0]['item_trib_id']
            mov_item_id = movimento_encargo_compativel[0]['mov_item_id']
            vr_base_calculo = float(movimento_encargo_compativel[0]['vr_base_calculo'])
            vr_encargo = float(movimento_encargo_compativel[0]['vr_encargo'])
            if diferenca > 0:
                if vr_encargo <= diferenca:
                    diferenca = vr_encargo - 0.1
                vr_encargo = vr_encargo - diferenca
            else:
                vr_encargo = vr_encargo + abs(diferenca)
            acertou_encargo = acerta.set_acerta_encargo(vr_encargo, trib_id)
            if acertou_encargo:
                print "MOV_TRIB_ID:%s\t VR_ENCARGO: %s\t OK!" % \
                      (trib_id, vr_encargo)
            else:
                print "FALHA:\t\t MOVIMENTO_TRIB_ID: %s" % trib_id
