# -*- coding: utf-8 -*-

import os
import psycopg2
import psycopg2.extras


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results

print 'Iforme os seguintes dados'
erp_host = raw_input('Ip do ERP: ')
erp_usuario = raw_input('Usuario do postgres ERP: ')
erp_nome = raw_input('Nome do Banco ERP: ')
flag =  raw_input('Supervisor está no mesmo banco do ERP?(S/N) ')

if flag.upper() == 'N':
    sup_host = raw_input('Ip do Supervisor: ')
    sup_usuario = raw_input('Usuario do postgres Supervisor: ')
    sup_nome = raw_input('Nome do Banco Supervisor: ')

data_init = raw_input('Data inicial(DD-MM-AAAA):').split('-')
data_fim = raw_input('Data final(DD-MM-AAAA):').split('-')
data_init = data_init[2] + '-' + data_init[1] + '-' + data_init[0]
data_fim = data_fim[2] + '-' + data_fim[1] + '-' + data_fim[0]
cont = 0
try:
    print '>>>>>> Alterando notas......\n'
    conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host, connect_timeout=3)
    cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    _cr = cr
    if flag.upper() == 'N':
        conn_s = psycopg2.connect(database=sup_nome, user=sup_usuario, host=sup_host, connect_timeout=3)
        _cr = conn_s.cursor(cursor_factory=psycopg2.extras.DictCursor)

    try:
        cr.execute("""SELECT capa.id, 
                             capa.numero_nf,
                             capa.serie_nf,
                             capa.data_emissao,
                             modelo.fismnf_codigo
                      FROM fiscal_nf_capa                AS capa 
                      INNER JOIN fiscal_modelo_nf_series AS series ON series.id = capa.modelo_nf_series_id
                      INNER JOIN fiscal_modelo_nf        AS modelo ON modelo.id = series.modelo_nf_id
                      WHERE capa.data_emissao >= '{inicio} 00:00:01'
                        AND capa.data_emissao <= '{fim} 23:59:59'
                        AND capa.state = '3'
                        AND modelo.fismnf_codigo IN ('65', '91')
                    """.format(inicio=data_init,
                               fim=data_fim))
        dados_erp = dictfetchall(cr)
        numeros = []
        series = []
        for i in dados_erp:
            i.get('numero_nf') and numeros.append('%s' % i.get('numero_nf'))
            i.get('serie_nf') and series.append('%s' % i.get('serie_nf'))

        numeros = list(set(numeros))
        series = list(set(series))
        _cr.execute("""SELECT supcap_nro_cupom   AS numero,
                              supcap_caixa       AS caixa,
                              supcap_data_inicio AS data,
                              supcap_tipo        AS tipo
                       FROM supervisor_mov_capa 
                       WHERE supcap_caixa IN ({caixas})
                         AND supcap_nro_cupom IN ({numeros})
                    """.format(caixas=','.join(series),
                               numeros=','.join(numeros)))
    except Exception as e:
        print 'Erro ao consultar notas: %s' % e

    try:
        dict_sup = {}
        for i in dictfetchall(_cr):
            chave = '%s-%s' % (i.get('numero'), i.get('caixa'))
            dict_sup[chave] = i

        update = []
        for i in dados_erp:
            chave = '%s-%s' % (i.get('numero_nf'), i.get('serie_nf'))
            # notas que nao estao no SUPERVISOR, apenas no ERP
            if not dict_sup.get(chave) or (dict_sup.get(chave).get('tipo') == 'D' and i.get('fismnf_codigo') == '65' or
                                           dict_sup.get(chave).get('tipo') != 'D' and i.get('fismnf_codigo') != '65'):
                continue

            if str(i.get('data_emissao'))[:19] != str(dict_sup.get(chave).get('data'))[:19]:
                cr.execute("""UPDATE fiscal_nf_capa SET data_emissao = '%s' WHERE id = %s;
                              COMMIT;""" %
                           (str(dict_sup.get(chave).get('data'))[:19], i.get('id')))
                cont += 1

    except Exception as e:
        print 'Erro ao atualizar notas: %s' % e

except Exception as e:
    print 'Erro ao atualizar a base:%s' % e

print 'Finalizado, %s notas alteradas' % cont
