#!/usr/bin/python
# -*- encoding: utf-8 -*-
import psycopg2
import getpass


class AcertaMovimento():
    def __init__(self):
        self.conn = self.newConnection()
        self.cr = self.conn.cursor()
        self.data_inicio = raw_input('Data inicio (Ex: 2015-01-20): ')
        self.data_fim = raw_input('Data Final (Ex: 2015-01-30): ')

    def newConnection(self):
        try:
            database = raw_input('Nome da base: ')
            host = raw_input('Host: ')
            user = raw_input('Usuario do banco: ')
            password = getpass.getpass('Senha do banco: ')
            port = raw_input('Porta (Normalmente 5432): ')
            conn = psycopg2.connect(database=database, user=user, password=password, host=host,
                                    port=port, connect_timeout=3)
            return conn
        except:
            print "Erro ao conectar ao banco de dados"
            exec exit()

    def dictfetchall(self, cr):
        """Retorna todas as linhas de um cursor como um dicionario"""
        desc = cr.description
        return [dict(zip([col[0] for col in desc], row)) for row in cr.fetchall()]

    def getCumpomCancelamento(self, cr):
        sql = """
                SELECT id,
                       coo,
                       ecf_id
                FROM   ecf_cupons_capa
                WHERE  tipo_cupom = 'C'
                AND date_cupom >= '%s'
                AND date_cupom <= '%s'
        """ % (self.data_inicio, self.data_fim)
        cr.execute(sql)
        dados = self.dictfetchall(cr)
        return dados

    def getCupomVenda(self, cr, coo, ecf_id):
        sql = """
                SELECT id
                FROM   ecf_cupons_capa
                WHERE  coo = %d
                       AND ecf_id = %d
        """ % (coo, ecf_id)
        cr.execute(sql)
        dados = self.dictfetchall(cr)
        return dados

    def getSequenciaItemCancelado(self, cr, cupom_id):
        sql = """
                SELECT sequencia,
                       produto_id,
                       grade_id
                FROM   estoque_movimento_itens
                WHERE  cupom_id = %d
                       AND item_cancelado = true
            """ % cupom_id
        cr.execute(sql)
        dados = self.dictfetchall(cr)
        return dados

    def deletaItemCancelado(self, cr, cupom_id, sequencia, produto_id, grade_id):
        try:
            sql = """
                    DELETE FROM estoque_movimento_itens
                    WHERE  cupom_id = %d
                           AND sequencia = %d
                           AND produto_id = %d
                           AND grade_id = %d
                           AND item_cancelado = TRUE
            """ % (cupom_id, sequencia, produto_id, grade_id)
            cr.execute(sql)
            cr.connection.commit()
            return True
        except:
            cr.connection.rollback()
            return False

    def getItemCupomId(self, cr, cupom_id, sequencia, produto_id, grade_id):
        sql = """
                SELECT id
                FROM   estoque_movimento_itens emi
                WHERE  cupom_id = %d
                AND    sequencia = %d
                AND    produto_id = %d
                AND    grade_id = %d
        """ % (cupom_id, sequencia, produto_id, grade_id)
        cr.execute(sql)
        dados = self.dictfetchall(cr)
        return dados

    def principal(self):
        cupons_cancelamento = self.getCumpomCancelamento(self.cr)
        for cupons in cupons_cancelamento:
            cupom_cancelado_id = cupons['id']
            ecf_id = cupons['ecf_id']
            coo = cupons['coo'] - 1
            cupons_venda_id = self.getCupomVenda(self.cr, coo, ecf_id)
            for i in cupons_venda_id:
                cupom_venda_id = i['id']
                seq_itens_cancelados = self.getSequenciaItemCancelado(self.cr, cupom_venda_id)
                for x in seq_itens_cancelados:
                    sequencia = x['sequencia']
                    produto_id = x['produto_id']
                    grade_id = x['grade_id']
                    item_id = self.getItemCupomId(self.cr, cupom_cancelado_id, sequencia,
                                                  produto_id, grade_id)
                    if item_id:
                        deletou = self.deletaItemCancelado(self.cr, cupom_cancelado_id, sequencia,
                                                           produto_id, grade_id)
                        produto_id = str(produto_id).zfill(10)
                        sequencia = str(sequencia).zfill(4)
                        if deletou:
                            print "Cupom_id: %d\t\tProduto_id: %s\t\tSequencia: %s\tOK!" \
                                  "" % (cupom_cancelado_id, produto_id, sequencia)
                        else:
                            print "Cupom_id: %d\t\tProduto_id: %s\t\tSequencia: %s\tFALHOU!" \
                                  "" % (cupom_cancelado_id, produto_id, sequencia)

acerto = AcertaMovimento()
acerto.principal()
