# -*- coding: utf-8 -*-

# Este script pesquisa na sefaz uma chave valida que foi perdida, fornecendo uma chave inicial, tenta uma
# por uma, mudando o final da chave e o digito verificador


# from nfe.nfc_e import nfce as nfc_e
from nfe.nf_e400 import nfe_400 as nfe
import psycopg2.extras
from SigUtils import calcDigito



def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results


class get_browse(object):
    def __init__(self, d):
        for a, b in d.items():
            if isinstance(b, (list, tuple)):
                setattr(self, a, [get_browse(x) if isinstance(x, dict) else x for x in b])
            else:
                setattr(self, a, get_browse(b) if isinstance(b, dict) else b)

print ('Iforme os seguintes dados')
erp_host = raw_input('Ip do ERP: ')
erp_usuario = raw_input('Usuario do postgres ERP: ')
erp_nome = raw_input('Nome do Banco ERP: ')
erp_senha = raw_input('Senha do Banco ERP: ')
chave = raw_input('Chave base para consutla')

cont = 1
msg = []
try:
    print ('>>>>>> Consultando chaves na SEFAZ......\n')
    conn = psycopg2.connect(database=erp_nome, user=erp_usuario, host=erp_host,
                            password=erp_senha, connect_timeout=20)
    cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
    try:
        cr.execute("""SELECT fp.company_id,
                             fp.certificado_conteudo, 
                             fp.chave_conteudo, 
                             fp.fispar_nfce_tentativa_envio, 
                             fp.fispar_nfce_conexao_timeout,
                             ap.uf,
                             ap.cpf_cnpj as cnpj         
                      FROM fiscal_parametro AS fp
                      LEFT JOIN res_company AS rc ON rc.id = fp.company_id
                      LEFT JOIN adm_pessoa  AS ap ON ap.id = rc.rescon_pessoa_id
                      WHERE fp.company_id = 1
                   """)
        parametros = {}
        for i in dictfetchall(cr):
            par = get_browse(i)

        while cont < 100000000:
            parametro = par
            if not parametro.uf:
                raise Exception('Erro: a Empresa %s nao possui UF cadastrado no endereco da pessoa!' %
                                parametro.company_id)
            ambiente = int(chave[34:35])
            nova_chave = chave[:35] + ('%s' % cont).zfill(8)
            cont += 1
            dv = calcDigito.baseModulo(nova_chave, 98765432)
            dv = '0' if dv.__len__() > 1 else dv
            nova_chave += dv
            nf = nfe(parametro.certificado_conteudo,
                     parametro.chave_conteudo,
                     ambiente,
                     parametro.uf,
                     False)
            nf.process.tentativas = parametro.fispar_nfce_tentativa_envio or 5
            nf.process.timeout = parametro.fispar_nfce_conexao_timeout or 10
            print(nova_chave)
            processo, __ = nf.consultar_nota(nova_chave)
            if processo.resposta.cStat.valor in (u'100', u'150'):
                msg.append('Nota encontrada na sefaz: -> FATURADA: %s' % nova_chave)
                break

            elif processo.resposta.cStat.valor == u'101':
                msg.append('Nota encontrada na sefaz: -> cANCELADA: %s' % nova_chave)
                break

            # nota nao encontrada na sefaz
            elif processo.resposta.cStat.valor in (u'137', u'217'):
                pass


        if msg:
            print ('\n'.join(msg))
        else:
            print ('Nenhuma chave encontrada!')

    except Exception as e:
        print ('Erro ao atualizar notas: %s' % e)

except Exception as e:
    print ('Erro ao conectar com a Base de dados:%s' % e)
