# -*- coding: utf-8 -*-

# Script para recuperar notas perdidas do banco do caixa e no supervisor.
# o arquivo do log do exportar será lido e os inserts gravados serão executados.

import os
import psycopg2
import psycopg2.extras


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results

print 'Iforme os seguintes dados'
sup_host = raw_input('Ip do Supervisor: ')
sup_usuario = raw_input('Usuario do postgres Supervisor: ')
sup_nome = raw_input('Nome do Banco Supervisor: ')
sup_senha = raw_input('Senha do Banco Supervisor: ')
nome_arquivo = True

while nome_arquivo:
    try:
        nome_arquivo = raw_input('Arquivo de log(Ex: /logs/exportar.01-09-2019.log): ')
        print '>>>>>> Recuperando notas......\n'
        try:
            conn_s = psycopg2.connect(database=sup_nome, user=sup_usuario, host=sup_host,
                                      connect_timeout=5, password=sup_senha)
            cr = conn_s.cursor(cursor_factory=psycopg2.extras.DictCursor)
        except Exception as e:
            print 'Erro ao conectar no banco informado: %s' % e
            break

        try:
            file = open(nome_arquivo, 'r')
            linhas = file.readlines()
            file.close()

        except Exception as e:
            print 'Erro ao ler arquivo de log informado: %s' % e
            continue

        try:
            ano_mes = ''
            sql = []
            new_capa_id = False
            new_fechamento_id = False
            new_kit_vendido_id = False
            old_capa_id = False
            old_fechamento_id = False
            old_kit_vendido_id = False
            cont = 0
            for linha in linhas:
                if not ano_mes or linha[:7] == ano_mes:
                    ano_mes = linha[:7]
                    if 'supervisor_mov_capa.id:' in linha:
                        old_capa_id = linha.split(' ')[-1].replace('\n', '')
                    elif 'supervisor_mov_fechamentos.id:' in linha:
                        old_fechamento_id = linha.split(' ')[-1].replace('\n', '')

                    elif 'supervisor_mov_kits_vendidos.id:' in linha:
                        old_kit_vendido_id = linha.split(' ')[-1].replace('\n', '')

                    if sql:
                        sql = ''.join(sql)
                        if old_capa_id and 'capa_id' in sql:
                            sql = sql.replace("'%s'" % old_capa_id, "'%s'" % new_capa_id)

                        if old_fechamento_id and 'fechamentos_id' in sql:
                            sql = sql.replace("'%s'" % old_fechamento_id, "'%s'" % new_fechamento_id)

                        if old_kit_vendido_id and 'kit_vendido_id' in sql:
                            sql = sql.replace("'%s'" % old_fechamento_id, "'%s'" % new_kit_vendido_id)

                        try:
                            cr.execute(sql)
                            dados = dictfetchall(cr)
                        except Exception as e:
                            print 'Erro ao inserir o regristro: %s\nsql: %s' % (e, sql)
                            break

                        if 'INSERT INTO supervisor_mov_capa' in sql:
                            new_capa_id = str(dados[0].get('id'))
                            cont += 1

                        if 'INSERT INTO supervisor_mov_fechamentos' in sql:
                            new_fechamento_id = str(dados[0].get('id'))

                        if 'INSERT INTO supervisor_mov_kits_vendidos' in sql:
                            new_kit_vendido_id = str(dados[0].get('id'))


                        sql = []

                    continue

                if linha != '\n':
                    sql.append(linha)


        except Exception as e:
            print 'Erro ao atualizar notas: %s' % e
            continue

        cr.execute('COMMIT;')
    except Exception as e:
        print 'Erro ao atualizar a base:%s' % e
        continue

    print 'Notas do arquivo %s importadas, %s nostas importadas' % (nome_arquivo, cont)

print 'Fim da importação'
