# -*- coding: utf-8 -*-

import os
import psycopg2
import psycopg2.extras


def dictfetchall(_cr):
    """ fetchall -> dictfetchall. Essa funcao converte o resultado do fectchall de um cursor
     para dictfetchall. O psycopg2 nao possui a funcionalidade dictfetchall, por isso a
     conversao."""

    # testa resultados armazenados
    results = _cr.fetchall()
    if results < 1:
        return results

    # substitui resultados das listas por dicionarios
    rownum = 0
    for row in results:
        dictrow = {}
        dictnum = 0
        for col in _cr.description:
            dictrow[col[0]] = row[dictnum]
            dictnum += 1

        results[rownum] = dictrow
        rownum += 1

    return results

print 'Iforme os seguintes dados'
host = raw_input('Ip do Servidor: ')
porta = raw_input('Porta do postgres: ')
usuario = raw_input('Usuario do postgres: ')
senha = raw_input('Senha do postgres: ')
nome = raw_input('Nome do Banco a ser criado: ')
versao = raw_input('Versão do cliente: ')
arquivo = raw_input('Diretório do arquivo de backup(ex: /tmp/base.backup): ')
nome_bd = '%s_%s' % (versao, nome)
erro = False
try:
    print '>>>>>> Criando Banco......\n'
    cmd = 'PGPASSWORD={senha} createdb -U{usuario} -E utf8 {banco} -h{host}; ' \
          'pg_restore -h{host} -p{porta} -U{usuario} -d{banco} --verbose {arquivo} | ' \
          'psql -U{usuario} -p{porta} -h{host} {banco}'.format(senha=senha,
                                                               banco=nome_bd,
                                                               usuario=usuario,
                                                               porta=porta,
                                                               host=host,
                                                               arquivo=arquivo)
    os.system(cmd)

except Exception as e:
    print '\nErro ao restaurar o banco %s: %s\n' % (nome_bd, e)
    erro = True

if not erro:
    try:
        print '>>>>>> Alterando Banco......\n'
        conn = psycopg2.connect(database=nome_bd, user=usuario, host=host, password=senha,
                                connect_timeout=3)
        _cr = conn.cursor(cursor_factory=psycopg2.extras.DictCursor)
        try:
            _cr.execute('COMMIT;')
            _cr.execute("""SELECT name 
                           FROM ir_module_module 
                           WHERE name = 'supervisor'
                             AND state = 'installed';""")
            if dictfetchall(_cr):
                _cr.execute("""UPDATE supervisor_mov_capa SET supcap_ambiente = 'H';
                               COMMIT;
                            """)
            _cr.execute("""SELECT name 
                           FROM ir_module_module 
                           WHERE name = 'ecf'
                             AND state = 'installed';""")
            if dictfetchall(_cr):
                _cr.execute("""UPDATE estoque_parametro SET estpar_super_host = '', 
                                                            estpar_super_host_erp = '', 
                                                            estpar_super_db = '';                      
                               COMMIT;""")
        except:
            pass

        _cr.execute("""UPDATE ir_cron SET active = False WHERE id > 7 OR name ilike '%mail%';
                       UPDATE res_users SET password = 'sig';
                    """)
        _cr.execute("""SELECT name 
                       FROM ir_module_module 
                       WHERE name = 'adm'
                         AND state = 'installed';
                    """)
        if dictfetchall(_cr):
            _cr.execute("""UPDATE fiscal_parametro SET fispar_nfe_ambiente = 2;
                           UPDATE fiscal_modelo_nf_series SET ambiente = 2 WHERE ambiente = 1;
                        """)

        _cr.execute('COMMIT;')

        print('\n\nFinalizado com Sucesso\n\nBanco "%s" criado no servidor "%s\n"' % (nome_bd, host))
    except Exception as e:
        print('\nErro ao atualizar a base:%s\n' % e)
