#!/usr/bin/env python
# -*- coding: utf-8 -*-

import os, sys, subprocess
import re, fileinput
from setuptools import setup, find_packages
from os.path import join, dirname

def get_variable(regex):
    initfile = file('__init__.py')
    for line in initfile:
        match = re.search(r'^'+regex+'\s+=\s+(.*)', line)
        if match:
            value = eval(match.group(1))
            return value


def find_package_dir():
    pkg_dir = {}
    for pkg in packages:
        for root, dirnames, filenames in os.walk(pkg):
            pkg_dir.setdefault(pkg, join(root,'')[:-1])
            break

    return pkg_dir


def find_package_data():
    pkg_data = {}

    for pkg in packages:
        for root, dirnames, filenames in os.walk(pkg):
            for filename in filenames:
                if not re.match(r'.*(\.py|\.pyc|\.pyo|\~)$', filename):
                    pkg_data.setdefault(pkg, []).append(join(root.replace(pkg+'/',''), filename))

    return pkg_data


def update_modules(version):
    mjver = '.'.join(str(v) for v in version[:2])
    modules = {}
    for pkg in packages:
        for root, dirnames, filenames in os.walk(pkg):
            for filename in filenames:
                if re.match(r'__(openerp|odoo)__\.py$', filename):
                    mod_file=fileinput.input(join(root.replace(pkg+'/',''), filename),inplace=True)
                    for line in mod_file:
			regex = re.compile(r'(^\s+\'version\':)(.*)$')
			match = re.match(regex, line)
			if match:
			    pattern = match.group(2).strip(' ').strip(',').strip("'")
                            newline = line.replace(pattern,'%s' % version)
			    print >> sys.stderr, "Updated: %s \033[50G -> version: %s" % (join(root.replace(pkg+'/',''), filename),version)
			    print "%s" % newline.rstrip()
			else:
			    print "%s" % line.rstrip()


### Debug ###
#dirs = find_package_dir()
#for d in dirs:
#    print "%s: %s\n" % (d,dirs.get(d))

#data = find_package_data()
#for pkg in data:
#    print "%s: %s\n\n" % (pkg,data.get(pkg))


version  = get_variable('version')
revision = get_variable('revision')
packages = find_packages()

if sys.argv[1] == 'sdist':
    mjver = '.'.join(str(v) for v in version[:2])
    update_modules(str(mjver+'.'+version[2].upper()+str(revision)))

setup(
    name=get_variable('__name__'),
    version='.'.join([str(v) for v in version]).lower()+str(revision),
    author=get_variable('__author__'),
    author_email=get_variable('__author_email__'),
    description=get_variable('__description__'),
    license=get_variable('__license__'),
    classifiers=get_variable('__classifiers__'),
    keywords=get_variable('__keywords__'),
    url=get_variable('__url__'),
    packages=packages,
    package_dir=find_package_dir(),
    package_data=find_package_data(),
    include_package_data=True,
)

if sys.argv[1] == 'sdist':
    print "New version generated at dist/ folder"
    print 80 * '*','\n'
    print 21 * ' '+'NÃO SE ESQUEÇA DE FAZER O COMMIT !!!'
    print '\n',80 * '*'

#    subprocess.check_output('svn diff | less', shell=True)
